(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    134622,       3744]*)
(*NotebookOutlinePosition[    176472,       5062]*)
(*  CellTagsIndexPosition[    176389,       5056]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[TextData[Cell[BoxData[GridBox[{
        {
          ButtonBox[
            StyleBox["\[FirstPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageFirst"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"First Slide"], 
          ButtonBox[
            StyleBox["\[LeftPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPagePrevious"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Previous Slide"], 
          ButtonBox[
            StyleBox["\[RightPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageNext"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Next Slide"], 
          ButtonBox[
            StyleBox["\[LastPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageLast"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Last Slide"], " ", 
          ButtonBox[
            StyleBox[
              RowBox[{
                CounterBox["SlideShowNavigationBar"], \(\(\ \)\(of\)\(\ \)\), 
                
                
                CounterBox["SlideShowNavigationBar", {None, 
                  "SlideShowHeader", -1}]}],
              "SR"],
            ButtonFrame->"None"]}
        }]]]], "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Using Combinatorial and Algebraic Techniques for \
Automatic Generation of Loop Invariants ",
  TextAlignment->Center,
  TextJustification->0,
  FontFamily->"Times New Roman CE",
  FontSize->28,
  FontWeight->"Bold",
  FontSlant->"Plain"]], "Title",
  CellMargins->{{Inherited, Inherited}, {5, 10}},
  TextAlignment->Center,
  TextJustification->0,
  FontWeight->"Plain",
  FontSlant->"Italic",
  FontColor->GrayLevel[1],
  Background->RGBColor[0.137255, 0.435294, 0.0745098]],

Cell[TextData[{
  "Laura Ildik\[OAcute] Kov\[AAcute]cs, Tudor Jebelean, Carsten Schneider\n",
  StyleBox["\n",
    FontSize->4],
  StyleBox["Research Institute for  Symbolic Computation, Linz, Austria\n\
Institute eAustria, Timisoara, Romania",
    FontSize->12]
}], "Text",
  CellMargins->{{Inherited, Inherited}, {10, 12}},
  TextAlignment->Center,
  TextJustification->0,
  FontSize->16],

Cell["Program Verification in Theorema", "Section",
  CellDingbat->"\[DiamondSuit]",
  CellMargins->{{Inherited, Inherited}, {10, Inherited}},
  FontFamily->"Times New Roman",
  FontSize->22,
  FontColor->RGBColor[0.137255, 0.435294, 0.0745098]],

Cell["Imperative Program Verification in Theorema", "Section",
  CellDingbat->"\[DiamondSuit]",
  CellMargins->{{Inherited, Inherited}, {10, Inherited}},
  TextAlignment->Left,
  TextJustification->0,
  FontFamily->"Times New Roman",
  FontSize->22,
  FontColor->RGBColor[0.137255, 0.435294, 0.0745098]],

Cell["Generation of Invariants", "Section",
  CellDingbat->"\[DiamondSuit]",
  CellMargins->{{Inherited, Inherited}, {10, Inherited}},
  FontFamily->"Times New Roman",
  FontSize->22,
  FontColor->RGBColor[0.137255, 0.435294, 0.0745098]],

Cell["Conclusion and Future Work", "Section",
  CellDingbat->"\[DiamondSuit]",
  CellMargins->{{19.0625, Inherited}, {10, Inherited}},
  TextAlignment->Left,
  TextJustification->0,
  FontFamily->"Times New Roman",
  FontSize->22,
  FontColor->RGBColor[0.137255, 0.435294, 0.0745098]],

Cell[TextData[Cell[BoxData[GridBox[{
        {
          ButtonBox[
            StyleBox["\[FirstPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageFirst"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"First Slide"], 
          ButtonBox[
            StyleBox["\[LeftPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPagePrevious"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Previous Slide"], 
          ButtonBox[
            StyleBox["\[RightPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageNext"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Next Slide"], 
          ButtonBox[
            StyleBox["\[LastPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageLast"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Last Slide"], " ", 
          ButtonBox[
            StyleBox[
              RowBox[{
                CounterBox["SlideShowNavigationBar"], \(\(\ \)\(of\)\(\ \)\), 
                
                
                CounterBox["SlideShowNavigationBar", {None, 
                  "SlideShowHeader", -1}]}],
              "SR"],
            ButtonFrame->"None"]}
        }]]]], "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["Program Verification in ",
    FontSize->25],
  StyleBox["Theorema",
    FontSize->25,
    FontSlant->"Italic"],
  StyleBox[" ",
    FontSize->25]
}], "Section",
  CellDingbat->"\[DiamondSuit]",
  FontColor->RGBColor[0.137255, 0.435294, 0.0745098]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["Theorema",
    FontSize->16,
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[" ",
    FontSize->16],
  "- ",
  StyleBox["a computer aided mathematical assistant for automated reasoning",
    FontColor->GrayLevel[0]]
}], "Subsection",
  FontSize->14],

Cell[TextData[{
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{
            StyleBox["{",
              SpanMaxSize->Infinity], GridBox[{
                {\(Computing\ \((simplifying)\)\)},
                {"Solving"},
                {"Proving"}
                },
              ColumnAlignments->{Left}], 
            StyleBox["}",
              ShowContents->False]}], " "}], TraditionalForm]]],
  Cell[BoxData[
      FormBox[
        StyleBox[
          TagBox["",
            (#&)],
          FontSize->16], TraditionalForm]]],
  "\n\n",
  StyleBox["using:",
    FontWeight->"Bold",
    FontSlant->"Italic",
    FontColor->RGBColor[0.500008, 0, 0]],
  " specified 'knowledge bases' \n",
  StyleBox["applying:",
    FontWeight->"Bold",
    FontSlant->"Italic",
    FontColor->RGBColor[0.500008, 0, 0]],
  "  simplifiers, solvers and provers from the ",
  StyleBox["Theorema",
    FontSlant->"Italic"],
  " library\n"
}], "Text",
  CellDingbat->"\[EmptySmallCircle]",
  CellMargins->{{29.3125, Inherited}, {Inherited, Inherited}},
  FontSize->14],

Cell[TextData[{
  " ",
  Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{
            StyleBox["{",
              SpanMaxSize->Infinity], GridBox[{
                {"Composing"},
                {"Structuring"},
                {"Manipulating"}
                },
              ColumnAlignments->{Left}], 
            StyleBox["}",
              ShowContents->False]}], " "}], TraditionalForm]]],
  "   mathematical texts  \n"
}], "Text",
  CellDingbat->"\[EmptySmallCircle]",
  CellMargins->{{29.3125, Inherited}, {Inherited, Inherited}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Program Verification in Theorema",
  FontWeight->"Bold"]], "Text",
  FontSize->16,
  FontColor->RGBColor[0.501961, 0, 0]],

Cell[TextData[{
  StyleBox["'",
    FontWeight->"Bold",
    FontColor->RGBColor[0.500008, 0, 0]],
  StyleBox["Theorema",
    FontWeight->"Bold",
    FontSlant->"Italic",
    FontColor->RGBColor[0.500008, 0, 0]],
  StyleBox[" Language'",
    FontWeight->"Bold",
    FontColor->RGBColor[0.500008, 0, 0]],
  ":  higher order predicate logic (with equalities as rewrite rules)"
}], "Text",
  CellDingbat->"\[FilledSmallSquare]",
  CellMargins->{{28.625, Inherited}, {Inherited, Inherited}},
  FontSize->14],

Cell[TextData[{
  StyleBox["verification: proving specifications based on definitions (both \
are logical formulae) ",
    FontSlant->"Italic"],
  "\n",
  StyleBox["(B. Buchberger, A. Craciun, N. Popov, T. Jebelean)",
    FontSize->12]
}], "Text",
  CellMargins->{{28.625, Inherited}, {Inherited, Inherited}},
  FontSize->14],

Cell[TextData[{
  "Verification of Functional Programs  ",
  StyleBox["(N. Popov, T. Jebelean)",
    FontSize->12]
}], "Text",
  CellMargins->{{28.625, Inherited}, {Inherited, Inherited}},
  FontSize->14],

Cell["\<\
additionally: imperative language with interpretor and verifier\
\>", "Text",
  CellDingbat->"\[FilledSmallSquare]",
  CellMargins->{{28.625, Inherited}, {Inherited, Inherited}},
  FontSize->14],

Cell[TextData[{
  StyleBox["verification: generating verification conditions\n",
    FontSlant->"Italic"],
  StyleBox["(L. Kov\[AAcute]cs, ",
    FontSize->12],
  StyleBox["T. Jebelean",
    FontSize->12],
  StyleBox[")",
    FontSize->12]
}], "Text",
  CellMargins->{{28.625, Inherited}, {Inherited, Inherited}},
  FontSize->14]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Advantages of Program Verification in Theorema",
  FontWeight->"Bold"]], "Subsection",
  FontSize->16],

Cell["\<\
proofs in natural language and using natural style inferences\
\>", "Text",
  CellDingbat->"\[EmptySmallCircle]",
  CellMargins->{{27, Inherited}, {Inherited, Inherited}},
  FontSize->14],

Cell["\<\
access to powerful computing and solving algorithms (Mathematica)\
\>", "Text",
  CellDingbat->"\[EmptySmallCircle]",
  CellMargins->{{27, Inherited}, {Inherited, Inherited}},
  FontSize->14]
}, Open  ]]
}, Open  ]],

Cell[TextData[Cell[BoxData[GridBox[{
        {
          ButtonBox[
            StyleBox["\[FirstPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageFirst"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"First Slide"], 
          ButtonBox[
            StyleBox["\[LeftPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPagePrevious"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Previous Slide"], 
          ButtonBox[
            StyleBox["\[RightPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageNext"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Next Slide"], 
          ButtonBox[
            StyleBox["\[LastPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageLast"]}],
            ButtonStyle->"SlideHyperlink"], " ", 
          ButtonBox[
            StyleBox[
              RowBox[{
                CounterBox["SlideShowNavigationBar"], \(\(\ \)\(of\)\(\ \)\), 
                
                
                CounterBox["SlideShowNavigationBar", {None, 
                  "SlideShowHeader", -1}]}],
              "SR"],
            ButtonFrame->"None"]}
        }]]]], "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["Imperative Program ",
    FontSize->25],
  StyleBox["Verification",
    FontSize->25],
  StyleBox[" in Theorema",
    FontSize->25]
}], "Section",
  CellDingbat->"\[DiamondSuit]",
  TextAlignment->Left,
  TextJustification->0,
  FontColor->RGBColor[0.137255, 0.435294, 0.0745098]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Special Constructs for a Procedural Language",
  FontSize->18]], "Subsection",
  TextAlignment->Left,
  TextJustification->0,
  FontSize->36,
  FontColor->RGBColor[0.500008, 0, 0]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Specification",
  FontSize->16,
  FontSlant->"Italic"]], "Subsubsection",
  CellDingbat->"\[EmptyDownTriangle]",
  CellMargins->{{32.625, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0,
  FontSize->16],

Cell[TextData[StyleBox["Example: finding the closest integer to the cubic \
root ",
  FontColor->RGBColor[0.101961, 0.305882, 0.054902]]], "Text",
  CellDingbat->None,
  CellMargins->{{38, Inherited}, {Inherited, Inherited}},
  FontColor->RGBColor[0.501961, 0, 0]],

Cell[BoxData[
    \(Specification["\<CubicRoot\>", 
      CubicRoot[\(\(\[DownArrow]\)\(a\)\), \(\(\[UpArrow]\)\(r\)\)], \n\t
      Pre \[Rule] IsInteger[a]\  \[And] \ a \[GreaterEqual] 1, \n\t
      Post \[Rule] \((r - 1\/2)\)\^3 < a \[And] \((r + 1\/2)\)\^3 > 
            a]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Program",
  FontSize->16,
  FontSlant->"Italic"]], "Subsubsection",
  CellDingbat->"\[EmptyDownTriangle]",
  CellMargins->{{32.625, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0,
  FontSize->16],

Cell[BoxData[
    \(Program["\<CubicRoot\>", 
      CubicRoot[\(\(\[DownArrow]\)\(a\)\), \(\(\[UpArrow]\)\(r\)\)], \n\t
      Module[{x, s}, \[IndentingNewLine]\t\ \ \ \ \ \ \ \ \ \ \ x := 
          a; \[IndentingNewLine]\t\ \ \ \ \ \ \ \ \ \ \ r := 
          1; \[IndentingNewLine]\t\ \ \ \ \ \ \ \ \ \ s := 
          13/4; \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \tWHILE[\((x - s > 
              0)\), \n\t\t\t\ x := x - s; \[IndentingNewLine]\t\t\ \ \ \ s := 
            s + 6*r + 3; \[IndentingNewLine]\t\t\ \ \ \ r := 
            r + 1, \[IndentingNewLine]\t\t\ \ \ Assert \[Rule] \((x \
\[GreaterEqual] 1)\), \n\t\t\tTerminationTerm \[Rule] \((x - 
                s)\)\n\t\t]\n\t]\n]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Interpretor",
  FontSlant->"Italic"]], "Subsubsection",
  CellDingbat->"\[EmptyDownTriangle]",
  CellMargins->{{32, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0,
  FontSize->16],

Cell[CellGroupData[{

Cell[BoxData[
    \(Execute[CubicRoot[41, \ r]]; {r}\)], "Input",
  TextAlignment->Left,
  TextJustification->0],

Cell[BoxData[
    \({3}\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Verification Condition Generator",
  FontSlant->"Italic"]], "Subsubsection",
  CellDingbat->"\[EmptyDownTriangle]",
  CellMargins->{{32, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0,
  FontSize->16],

Cell[BoxData[
    \(VCG[Program["\<CubicRoot\>"], 
      Specification["\<CubicRoot\>"]]\)], "Input",
  TextAlignment->Left,
  TextJustification->0]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Approach : Hoare Logic, Weakest Precondition ",
  FontSize->19,
  FontColor->RGBColor[0.500008, 0, 0]]], "Subsection",
  TextAlignment->Left,
  TextJustification->0,
  FontColor->RGBColor[0.500008, 0, 0]],

Cell[TextData[{
  "\t\t\t\t     {P}\n\t\t\t                        ",
  StyleBox["\[LeftArrow]",
    FontSize->12,
    FontColor->RGBColor[1, 0, 1]],
  Cell[BoxData[
      \(TraditionalForm\`wp\_n\)],
    FontSize->12,
    FontColor->RGBColor[1, 0, 1]],
  "\n\t\t\t                   ",
  Cell[BoxData[
      \(TraditionalForm\`\(\(\ \)\(s\_1\)\)\)]],
  "   \n ",
  StyleBox["\t\t\t\t\t\t      ",
    FontSize->9],
  StyleBox["\[LeftArrow]",
    FontSize->9,
    FontColor->RGBColor[1, 0, 1]],
  Cell[BoxData[
      FormBox[
        StyleBox[\(wp\_\(n - 1\)\),
          FontSize->12], TraditionalForm]],
    FontSize->9,
    FontColor->RGBColor[1, 0, 1]],
  StyleBox["\n",
    FontSize->9],
  "\t\t\t \t        ",
  Cell[BoxData[
      \(TraditionalForm\`s\_2\)]],
  StyleBox[" ",
    FontColor->RGBColor[1, 0, 1]],
  " \n",
  StyleBox["\t\t\t ",
    FontSize->9],
  StyleBox["        \t",
    FontFamily->"Lucida Sans",
    FontSize->14,
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]],
  StyleBox["\t",
    FontSize->9],
  "       ",
  StyleBox["\[UpArrow] +",
    FontSize->22,
    FontWeight->"Bold",
    FontColor->RGBColor[1, 0, 1]],
  StyleBox[" ",
    FontSize->27,
    FontWeight->"Bold",
    FontColor->RGBColor[1, 0, 1]],
  Cell[BoxData[
      FormBox[
        StyleBox[GridBox[{
              {
                StyleBox["Verification",
                  FontSize->12]},
              {
                StyleBox["conditions",
                  FontSize->12]}
              }],
          FontSize->18], TraditionalForm]],
    FontSize->27,
    FontWeight->"Bold",
    FontColor->RGBColor[1, 0, 1]],
  StyleBox["     ",
    FontSize->10,
    FontColor->RGBColor[1, 0, 1]],
  StyleBox["              .                                                   \
                                                                              \
    ",
    FontSize->10],
  StyleBox["\n  \t\t\t\t\t\t        \[VerticalEllipsis]\n   \t\t              \
                                    ",
    FontSize->9],
  StyleBox["\[LeftArrow]",
    FontSize->9,
    FontColor->RGBColor[1, 0, 1]],
  Cell[BoxData[
      FormBox[
        StyleBox[\(wp\_1\),
          FontSize->12], TraditionalForm]],
    FontSize->9,
    FontColor->RGBColor[1, 0, 1]],
  "  \t",
  StyleBox["\n",
    FontSize->9],
  "\t\t\t\t        ",
  Cell[BoxData[
      \(TraditionalForm\`s\_n\)]],
  " \n\t\t\t\t     {Q}\n\t\t\t\t\t\t      \n\t\t\t\t    ",
  Cell[BoxData[
      \(TraditionalForm\`P \[Implies] wp\_n\)]]
}], "Text",
  TextAlignment->Left,
  TextJustification->0]
}, Open  ]]
}, Open  ]],

Cell[TextData[Cell[BoxData[GridBox[{
        {
          ButtonBox[
            StyleBox["\[FirstPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageFirst"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"First Slide"], 
          ButtonBox[
            StyleBox["\[LeftPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPagePrevious"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Previous Slide"], 
          ButtonBox[
            StyleBox["\[RightPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageNext"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Next Slide"], 
          ButtonBox[
            StyleBox["\[LastPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageLast"]}],
            ButtonStyle->"SlideHyperlink"], " ", 
          ButtonBox[
            StyleBox[
              RowBox[{
                CounterBox["SlideShowNavigationBar"], \(\(\ \)\(of\)\(\ \)\), 
                
                
                CounterBox["SlideShowNavigationBar", {None, 
                  "SlideShowHeader", -1}]}],
              "SR"],
            ButtonFrame->"None"]}
        }]]]], "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["Generation of Loop Invariants", "Section",
  CellDingbat->"\[DiamondSuit]",
  FontColor->RGBColor[0.137255, 0.435294, 0.0745098]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Our Approach: Combinatorial and Algebraic Methods",
  FontFamily->"Times New Roman"]], "Subsection",
  CellDingbat->None,
  CellMargins->{{106.625, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0,
  FontSize->18,
  FontColor->RGBColor[0.501961, 0, 0]],

Cell["Loops with only Assignments", "Subsubsection",
  CellDingbat->None,
  CellMargins->{{106, Inherited}, {Inherited, Inherited}},
  FontSize->18],

Cell["Loops with Conditionals", "Subsection",
  CellDingbat->None,
  CellMargins->{{106, Inherited}, {Inherited, Inherited}},
  FontSize->18,
  FontColor->RGBColor[0.137255, 0.435294, 0.0745098]],

Cell["Nested Loops", "Subsection",
  CellDingbat->None,
  CellMargins->{{106, Inherited}, {Inherited, Inherited}},
  FontSize->18,
  FontColor->RGBColor[0.137255, 0.435294, 0.0745098]]
}, Open  ]]
}, Open  ]],

Cell[TextData[Cell[BoxData[GridBox[{
        {
          ButtonBox[
            StyleBox["\[FirstPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageFirst"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"First Slide"], 
          ButtonBox[
            StyleBox["\[LeftPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPagePrevious"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Previous Slide"], 
          ButtonBox[
            StyleBox["\[RightPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageNext"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Next Slide"], 
          ButtonBox[
            StyleBox["\[LastPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageLast"]}],
            ButtonStyle->"SlideHyperlink"], " ", 
          ButtonBox[
            StyleBox[
              RowBox[{
                CounterBox["SlideShowNavigationBar"], \(\(\ \)\(of\)\(\ \)\), 
                
                
                CounterBox["SlideShowNavigationBar", {None, 
                  "SlideShowHeader", -1}]}],
              "SR"],
            ButtonFrame->"None"]}
        }]]]], "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Invariant Generation for Loops with Assignments ",
  FontFamily->"Times New Roman"]], "Section",
  CellDingbat->"\[DiamondSuit]",
  CellMargins->{{21.3125, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0,
  FontColor->RGBColor[0.137255, 0.435294, 0.0745098]],

Cell[CellGroupData[{

Cell["Non-mutual recurrences", "Subsection",
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  FontSize->24],

Cell[TextData[StyleBox["Example: finding the closest integer to the cubic \
root ",
  FontColor->RGBColor[0.137255, 0.435294, 0.0745098]]], "Subsubsection",
  CellDingbat->None,
  CellMargins->{{38, Inherited}, {Inherited, Inherited}},
  FontSize->16,
  FontColor->RGBColor[0.501961, 0, 0]],

Cell[BoxData[
    \(Program["\<CubicRoot\>", 
      CubicRoot[\(\(\[DownArrow]\)\(a\)\), \(\(\[UpArrow]\)\(r\)\)], \n\t
      Module[{x, s}, \[IndentingNewLine]\t\ \ \ \ \ \ \ \ \ \ \ x := 
          a; \[IndentingNewLine]\t\ \ \ \ \ \ \ \ \ \ \ r := 
          1; \[IndentingNewLine]\t\ \ \ \ \ \ \ \ \ \ s := 
          13/4; \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \tWHILE[\((x - s > 
              0)\), \n\t\t\t\ x := x - s; \[IndentingNewLine]\t\t\ \ \ \ s := 
            s + 6*r + 3; \[IndentingNewLine]\t\t\ \ \ \ r := 
            r + 1, \[IndentingNewLine]\t\t\ \ \ Assert \[Rule] \((x \
\[GreaterEqual] 1)\), \n\t\t\tTerminationTerm \[Rule] \((x - 
                s)\)\n\t\t]\n\t]\n]\)], "Input"],

Cell["We obtain the following recursion equations:", "Text",
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0,
  FontWeight->"Bold"],

Cell[BoxData[
    \(\(\(\ \)\(x\_0 = \
\(a\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ s\
\_0 = \(13/4\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ r\_0 = 
          1\)\)\)\)\)], "Input",
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0],

Cell[BoxData[
    \(x\_\(k + 1\) = \(x\_k - 
          s\_k\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ s\_\(k + \
1\) := \(s\_k + 6*r\_k + 3\ \ \ \ \ \ \ \ \ r\_\(k + 1\) = 
          r\_k + 1\)\)\)], "Input",
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0],

Cell[TextData[{
  "Explicit equations (by using Gosper Algorithm)  -",
  StyleBox[" RISC Combinatorics ",
    FontColor->RGBColor[0.501961, 0, 0]],
  StyleBox["Group (Paule-Schorn package)",
    FontColor->RGBColor[0.501961, 0, 0]],
  ": "
}], "Text",
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0,
  FontWeight->"Bold"],

Cell[BoxData[
    \(x\_k = \(1\/4 + a - 
          1\/2\ \((1 + k)\)\ \((1\/2 + k + 
                2\ k\^2)\)\ \ \ \ \ \ \ \ \ \ s\_k = \(1\/4 + 
            3\ \((1 + k)\)\^2\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ r\_k = 
          1 + k\)\)\)], "Input",
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0],

Cell[TextData[{
  "Eliminate k  ",
  StyleBox[" - by algebraic solving techniques:",
    FontColor->RGBColor[0.501961, 0, 0]]
}], "Text",
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0,
  FontWeight->"Bold"],

Cell[BoxData[
    RowBox[{
      RowBox[{"(", 
        RowBox[{"s", "=", 
          RowBox[{\(1\/4\), "+", 
            RowBox[{"3", "*", 
              SuperscriptBox[
                StyleBox["r",
                  FontWeight->"Bold",
                  FontSlant->"Italic",
                  FontColor->RGBColor[0, 0, 1],
                  Background->None], "2"]}]}]}], ")"}], "\[And]", "  ", 
      RowBox[{"(", 
        RowBox[{\(2*x\), "=", 
          RowBox[{\(1\/2\), "+", 
            RowBox[{"2", "*", 
              StyleBox["a",
                FontWeight->"Bold",
                FontSlant->"Italic",
                FontColor->RGBColor[0, 0, 1],
                Background->None]}], "+", 
            RowBox[{\((\(-3\)\/2)\), "*", 
              StyleBox["r",
                FontWeight->"Bold",
                FontSlant->"Italic",
                FontColor->RGBColor[0, 0, 1],
                Background->None]}], "+", 
            RowBox[{"3", "*", 
              SuperscriptBox[
                StyleBox["r",
                  FontWeight->"Bold",
                  FontSlant->"Italic",
                  FontColor->RGBColor[0, 0, 1],
                  Background->None], "2"]}], "+", 
            RowBox[{\((\(-2\))\), "*", 
              SuperscriptBox[
                StyleBox["r",
                  FontWeight->"Bold",
                  FontSlant->"Italic",
                  FontColor->RGBColor[0, 0, 1],
                  Background->None], "3"]}]}]}], ")"}]}]], "Input",
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0],

Cell["The Invariant property:", "Text",
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0,
  FontWeight->"Bold"],

Cell[BoxData[
    RowBox[{
      RowBox[{"(", 
        RowBox[{"s", "=", 
          RowBox[{\(1\/4\), "+", 
            RowBox[{"3", "*", 
              SuperscriptBox[
                StyleBox["r",
                  FontWeight->"Bold",
                  FontSlant->"Italic",
                  FontColor->RGBColor[0, 0, 1],
                  Background->None], "2"]}]}]}], ")"}], "\[And]", "  ", 
      RowBox[{"(", 
        RowBox[{\(2*x\), "=", 
          RowBox[{\(1\/2\), "+", 
            RowBox[{"2", "*", 
              StyleBox["a",
                FontWeight->"Bold",
                FontSlant->"Italic",
                FontColor->RGBColor[0, 0, 1],
                Background->None]}], "+", 
            RowBox[{\((\(-3\)\/2)\), "*", 
              StyleBox["r",
                FontWeight->"Bold",
                FontSlant->"Italic",
                FontColor->RGBColor[0, 0, 1],
                Background->None]}], "+", 
            RowBox[{"3", "*", 
              SuperscriptBox[
                StyleBox["r",
                  FontWeight->"Bold",
                  FontSlant->"Italic",
                  FontColor->RGBColor[0, 0, 1],
                  Background->None], "2"]}], "+", 
            RowBox[{\((\(-2\))\), "*", 
              SuperscriptBox[
                StyleBox["r",
                  FontWeight->"Bold",
                  FontSlant->"Italic",
                  FontColor->RGBColor[0, 0, 1],
                  Background->None], "3"]}]}]}], ")"}], " ", "\[And]", 
      " ", \((x \[GreaterEqual] 1)\)}]], "Input",
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[
    \(VCG[Program["\<CubicRoot\>"], 
      Specification["\<CubicRoot\>"]]\)], "Input",
  CellMargins->{{35.6875, Inherited}, {Inherited, Inherited}}],

Cell[BoxData[
    FormBox[
      RowBox[{
      "Lemma", \(\(\ \)\((\)\), "CubicRoot", \(\()\)\(:\)\(\n\)\), GridBox[{
            {
              RowBox[{\(for\ \(\(any\)\(:\)\)\), 
                RowBox[{
                  StyleBox["a",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], ",", 
                  StyleBox["r",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], ",", "x", ",", "s"}]}]}
            },
          ColumnAlignments->{Left}], "\n", 
        RowBox[{
          RowBox[{\((WHILE . Inv + Term)\), "\t", 
            RowBox[{
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{\(\(-1\)\/2\), "+", \(2*x\), "+", 
                      RowBox[{\((\(-2\))\), "*", 
                        StyleBox["a",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}], "+", 
                      RowBox[{\(3\/2\), "*", 
                        StyleBox["r",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}], "+", 
                      RowBox[{\((\(-3\))\), "*", 
                        SuperscriptBox[
                          StyleBox["r",
                            FontWeight->"Bold",
                            FontSlant->"Italic",
                            FontColor->RGBColor[0, 0, 1],
                            Background->None], "2"]}], "+", 
                      RowBox[{"2", "*", 
                        SuperscriptBox[
                          StyleBox["r",
                            FontWeight->"Bold",
                            FontSlant->"Italic",
                            FontColor->RGBColor[0, 0, 1],
                            Background->None], "3"]}]}], "=", "0"}], ")"}], 
                "\[And]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{\(\(-1\)\/4\), "+", "s", "+", 
                      RowBox[{\((\(-3\))\), "*", 
                        SuperscriptBox[
                          StyleBox["r",
                            FontWeight->"Bold",
                            FontSlant->"Italic",
                            FontColor->RGBColor[0, 0, 1],
                            Background->None], "2"]}]}], "=", "0"}], ")"}], 
                "\[And]", \(x \[GreaterEqual] 1\), 
                "\[And]", \(\(-1\)*s + x > 0\), 
                "\[And]", \((T1 := \(-1\)*s + x)\)}], "\[Implies]", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{\(1\/2\), "+", \(2*\((\(-1\)*s + x)\)\), "+", 
                      RowBox[{\((\(-2\))\), "*", 
                        StyleBox["a",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}], "+", 
                      StyleBox["r",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None], "+", 
                      RowBox[{\(1\/2\), "*", 
                        RowBox[{"(", 
                          RowBox[{"1", "+", 
                            StyleBox["r",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None]}], ")"}]}], "+", 
                      RowBox[{\((\(-3\))\), "*", 
                        SuperscriptBox[
                          RowBox[{"(", 
                            RowBox[{"1", "+", 
                              StyleBox["r",
                                FontWeight->"Bold",
                                FontSlant->"Italic",
                                FontColor->RGBColor[0, 0, 1],
                                Background->None]}], ")"}], "2"]}], "+", 
                      RowBox[{"2", "*", 
                        SuperscriptBox[
                          RowBox[{"(", 
                            RowBox[{"1", "+", 
                              StyleBox["r",
                                FontWeight->"Bold",
                                FontSlant->"Italic",
                                FontColor->RGBColor[0, 0, 1],
                                Background->None]}], ")"}], "3"]}]}], "=", 
                    "0"}], ")"}], "\[And]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{\(11\/4\), "+", "s", "+", 
                      RowBox[{"6", "*", 
                        StyleBox["r",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}], "+", 
                      RowBox[{\((\(-3\))\), "*", 
                        SuperscriptBox[
                          RowBox[{"(", 
                            RowBox[{"1", "+", 
                              StyleBox["r",
                                FontWeight->"Bold",
                                FontSlant->"Italic",
                                FontColor->RGBColor[0, 0, 1],
                                Background->None]}], ")"}], "2"]}]}], "=", 
                    "0"}], ")"}], 
                "\[And]", \(\(-1\)*s + x \[GreaterEqual] 1\), "\[And]", 
                RowBox[{
                  RowBox[{\(-3\), "+", \(\((\(-2\))\)*s\), "+", "x", "+", 
                    RowBox[{\((\(-6\))\), "*", 
                      StyleBox["r",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None]}]}], "<", "T1"}]}]}]}], "\n", 
          RowBox[{\((WHILE . Final)\), "\t", 
            RowBox[{
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{\(\(-1\)\/2\), "+", \(2*x\), "+", 
                      RowBox[{\((\(-2\))\), "*", 
                        StyleBox["a",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}], "+", 
                      RowBox[{\(3\/2\), "*", 
                        StyleBox["r",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}], "+", 
                      RowBox[{\((\(-3\))\), "*", 
                        SuperscriptBox[
                          StyleBox["r",
                            FontWeight->"Bold",
                            FontSlant->"Italic",
                            FontColor->RGBColor[0, 0, 1],
                            Background->None], "2"]}], "+", 
                      RowBox[{"2", "*", 
                        SuperscriptBox[
                          StyleBox["r",
                            FontWeight->"Bold",
                            FontSlant->"Italic",
                            FontColor->RGBColor[0, 0, 1],
                            Background->None], "3"]}]}], "=", "0"}], ")"}], 
                "\[And]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{\(\(-1\)\/4\), "+", "s", "+", 
                      RowBox[{\((\(-3\))\), "*", 
                        SuperscriptBox[
                          StyleBox["r",
                            FontWeight->"Bold",
                            FontSlant->"Italic",
                            FontColor->RGBColor[0, 0, 1],
                            Background->None], "2"]}]}], "=", "0"}], ")"}], 
                "\[And]", \(x \[GreaterEqual] 1\), 
                "\[And]", \(\(-1\)*s + x \[NotGreater] 0\)}], "\[Implies]", 
              RowBox[{
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{\(\(-1\)\/2\), "+", 
                        StyleBox["r",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}], ")"}], "3"], "<", 
                  StyleBox["a",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None]}], "\[And]", 
                RowBox[{
                  SuperscriptBox[
                    RowBox[{"(", 
                      RowBox[{\(1\/2\), "+", 
                        StyleBox["r",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}], ")"}], "3"], ">", 
                  StyleBox["a",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None]}]}]}]}], "\n", 
          RowBox[{\((WHILE . Term)\), "\t", 
            RowBox[{
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{\(\(-1\)\/2\), "+", \(2*x\), "+", 
                      RowBox[{\((\(-2\))\), "*", 
                        StyleBox["a",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}], "+", 
                      RowBox[{\(3\/2\), "*", 
                        StyleBox["r",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}], "+", 
                      RowBox[{\((\(-3\))\), "*", 
                        SuperscriptBox[
                          StyleBox["r",
                            FontWeight->"Bold",
                            FontSlant->"Italic",
                            FontColor->RGBColor[0, 0, 1],
                            Background->None], "2"]}], "+", 
                      RowBox[{"2", "*", 
                        SuperscriptBox[
                          StyleBox["r",
                            FontWeight->"Bold",
                            FontSlant->"Italic",
                            FontColor->RGBColor[0, 0, 1],
                            Background->None], "3"]}]}], "=", "0"}], ")"}], 
                "\[And]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{\(\(-1\)\/4\), "+", "s", "+", 
                      RowBox[{\((\(-3\))\), "*", 
                        SuperscriptBox[
                          StyleBox["r",
                            FontWeight->"Bold",
                            FontSlant->"Italic",
                            FontColor->RGBColor[0, 0, 1],
                            Background->None], "2"]}]}], "=", "0"}], ")"}], 
                "\[And]", \(x \[GreaterEqual] 1\), 
                "\[And]", \(\(-1\)*s + x > 0\)}], 
              "\[Implies]", \(\(-1\)*s + x \[GreaterEqual] 0\)}]}], "\n", 
          RowBox[{\((Init)\), "\t", 
            RowBox[{
              RowBox[{
                RowBox[{"IsInteger", "[", 
                  StyleBox["a",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], "]"}], "\[And]", 
                RowBox[{
                  StyleBox["a",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], "\[GreaterEqual]", "1"}]}], 
              "\[Implies]", 
              RowBox[{\((0 = 0)\), "\[And]", \((0 = 0)\), "\[And]", 
                RowBox[{
                  StyleBox["a",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], "\[GreaterEqual]", "1"}]}]}]}]}]}], 
      TraditionalForm]], "Output",
  CellLabel->"TS_Out[259]//TraditionalForm="]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Mutual recurrences",
  FontSize->25]], "Subsection",
  CellMargins->{{36, Inherited}, {Inherited, Inherited}}],

Cell[TextData[StyleBox["Example: Fibonacci numbers",
  FontColor->RGBColor[0.137255, 0.435294, 0.0745098]]], "Subsubsection",
  CellDingbat->None,
  CellMargins->{{37.3125, Inherited}, {Inherited, Inherited}},
  FontSize->16,
  FontColor->RGBColor[0.500008, 0, 0]],

Cell[BoxData[
    \(Specification["\<Fibonacci\>", 
      FibonacciProcSpec[\(\(\[DownArrow]\)\(n\)\), \(\(\[UpArrow]\)\(F\)\)], 
      Pre \[Rule] \((n > 0)\), Post \[Rule] \((F = FibExp[n])\)]\)], "Input",
  CellLabel->"TS_In[260]:="],

Cell[BoxData[
    \(Program["\<Fibonacci\>", \ 
      FibonacciProc[\(\(\[DownArrow]\)\(n\)\), \ \(\(\[UpArrow]\)\(\ \
\)\(F\)\)], \[IndentingNewLine]Module[{H, i}, \[IndentingNewLine]i := 
          n; \[IndentingNewLine]F := 1; \[IndentingNewLine]H := 
          1; \[IndentingNewLine]WHILE[
          i > 1, \[IndentingNewLine]H := H + F; \[IndentingNewLine]F := 
            H - F; \[IndentingNewLine]i := 
            i - 1, \[IndentingNewLine]TerminationTerm \[Rule] \ 
            i - 1]]]\)], "Input",
  CellLabel->"TS_In[261]:="],

Cell["We obtain the following  recursive equations:", "Text",
  CellMargins->{{13, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0,
  FontWeight->"Bold"],

Cell[BoxData[
    \(\(\(\ \)\(\(H\_1\) \((\(=\)\(1\))\)\
\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \(F\_1\) \
\((\(=\)\(1\))\)\)\)\)], "Input",
  TextAlignment->Left,
  TextJustification->0],

Cell[BoxData[
    \(H\_k = \(H\_\(k - 1\) + 
          F\_\(k - 1\)\ \((k \[GreaterEqual] 
                1)\)\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ F\
\_k = H\_k + \ F\_\(k - 1\)\ \((k \[GreaterEqual] 1)\)\)\)], "Input",
  TextAlignment->Left,
  TextJustification->0],

Cell[BoxData[
    \(i\_k = 
      i\_\(k - 1\) - 
        1\
\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \(i\_1\) \((\(=\)\(n\))\)\)], "Input"],

Cell[TextData[{
  "( ",
  Cell[BoxData[
      \(TraditionalForm\`k\)]],
  " is the iteration index)"
}], "Text"],

Cell[BoxData[
    RowBox[{" ", 
      RowBox[{\(By\ Gosper\), " ", "-", " ", 
        RowBox[{
          StyleBox["RISC",
            FontColor->RGBColor[0.501961, 0, 0]], 
          StyleBox[" ",
            FontColor->RGBColor[0.501961, 0, 0]], 
          StyleBox["Combinatorics",
            FontColor->RGBColor[0.501961, 0, 0]], 
          StyleBox[" ",
            FontColor->RGBColor[0.501961, 0, 0]], 
          RowBox[{
            StyleBox["Group",
              FontColor->RGBColor[0.501961, 0, 0]], ":"}]}]}]}]], "Text",
  CellDingbat->"\[FilledDiamond]",
  CellMargins->{{37, Inherited}, {Inherited, Inherited}},
  FontFamily->"Times New Roman",
  FontWeight->"Bold"],

Cell[BoxData[
    \(i\_k\  = \(\(n\)\(\ \)\(-\)\((k - 1)\)\(\ \)\)\)], "Input"],

Cell[BoxData[
    RowBox[{" ", 
      RowBox[{\(By\ Generating\ Functions\), " ", "-", 
        RowBox[{
          StyleBox["from",
            FontColor->RGBColor[0.501961, 0, 0]], 
          StyleBox["  ",
            FontColor->RGBColor[0.501961, 0, 0]], 
          RowBox[{
            StyleBox["Combinatorics",
              FontColor->RGBColor[0.501961, 0, 0]], ":", " "}]}]}]}]], "Text",\

  CellDingbat->"\[FilledDiamond]",
  CellMargins->{{37, Inherited}, {Inherited, Inherited}},
  FontFamily->"Times New Roman",
  FontWeight->"Bold"],

Cell[BoxData[
    \(\(\(F\_k\)\(=\)\(\ \)\(\(\(\[Phi]\^k\) \[Dash]\ \[Phi]\&^\^k\)\/\^\(\@5\
\)\)\(\ \)\)\)], "Input",
  TextAlignment->Left,
  TextJustification->0],

Cell[BoxData[
    \(\(\(H\_k\)\(=\)\(\ \)\(\(\(\[Phi]\^\(k + 
                  1\)\) \[Dash]\ \[Phi]\&^\^\(k + 1\)\)\/\^\(\@5\)\)\(\ \
\)\)\)], "Input",
  TextAlignment->Left,
  TextJustification->0],

Cell[BoxData[
    \(\((where : \ \ \ \[Phi]\  = \ \(1\  + \ \@5\)\/2)\)\)], "Text",
  CellMargins->{{50, Inherited}, {Inherited, Inherited}}],

Cell[TextData[{
  "Eliminate k  -  ",
  StyleBox["by algebraic solving techniques:",
    FontColor->RGBColor[0.501961, 0, 0]],
  " "
}], "Text",
  CellDingbat->"\[FilledDiamond]",
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  FontWeight->"Bold"],

Cell[BoxData[
    \(Invariant\  \[Congruent] \ \((F = \ \(\(\[Phi]\^\(n - i + 1\)\) \[Dash]\
\ \[Phi]\&^\^\(n - i + 1\)\)\/\^\(\@5\)\ )\)\  \[And] \ \((H = \ \(\(\[Phi]\^\
\(n - i + 2\)\) \[Dash]\ \[Phi]\&^\^\(n - i + 2\)\)\/\^\(\@5\)\ )\)\)], \
"Input",
  TextAlignment->Left,
  TextJustification->0],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Using Generating Functions [Stanley, 1980]",
  FontWeight->"Bold",
  FontColor->RGBColor[0.137255, 0.435294, 0.0745098]]], "Text",
  FontColor->RGBColor[0, 0.449226, 0]],

Cell[CellGroupData[{

Cell[TextData[{
  "1. Recurrence equation ",
  StyleBox["for all",
    FontColor->RGBColor[1, 0, 0]],
  " n\[Element]\[DoubleStruckCapitalZ]:"
}], "Text",
  TextAlignment->Left,
  TextJustification->0,
  FontSize->10,
  FontWeight->"Bold"],

Cell[BoxData[
    \(H\_k = \(H\_\(k - 1\) + F\_\(k - 1\)\  + \ 
          H\_\(\(ini\)\(\ \
\)\)\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ F\_k = 
        H\_k + \ F\_\(k - 1\) + F\_ini\)\)], "Input",
  TextAlignment->Left,
  TextJustification->0],

Cell[TextData[{
  "where ",
  Cell[BoxData[
      \(TraditionalForm\`\((H\_0 = \(H\_negative = \(F\_0 = \(F\_negative = 
                0\)\)\))\)\)]],
  ":"
}], "Text"],

Cell[BoxData[
    \(H\_ini = \
\(H\_1\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ F\
\_ini = F\_1 - H\_1\)\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "2. Switch to Generating Functions - by summation:\n\tF(z) = ",
  Cell[BoxData[
      \(TraditionalForm\`\[Sum]\+k\( F\_k\) z\^k\)]],
  "\n\tH(z) = ",
  Cell[BoxData[
      \(TraditionalForm\`\[Sum]\+k\( H\_k\) z\^k\)]]
}], "Text",
  TextAlignment->Left,
  TextJustification->0,
  FontSize->10,
  FontWeight->"Bold"],

Cell["\[DoubleDownArrow]", "Text",
  CellMargins->{{27, Inherited}, {Inherited, Inherited}},
  GeneratedCell->True],

Cell["   Harmonic Forms:", "Text",
  TextAlignment->Left,
  TextJustification->0,
  FontWeight->"Bold"],

Cell[BoxData[
    \(H \((z)\)\  = \ z\ H \((z)\) + z\ F \((z)\)\  + \(H\_ini\) z\)], "Input",\

  TextAlignment->Left,
  TextJustification->0],

Cell[BoxData[
    \(F \((z)\)\  = \ H \((z)\)\  - \ z\ F \((z)\) + \(F\_ini\) z\)], "Input",\

  TextAlignment->Left,
  TextJustification->0],

Cell["\[DoubleDownArrow]", "Text",
  CellMargins->{{24.3125, Inherited}, {Inherited, Inherited}},
  GeneratedCell->True],

Cell["  Solving a system of 2 equations in 2 unknowns:", "Text",
  TextAlignment->Left,
  TextJustification->0,
  FontWeight->"Bold"],

Cell[BoxData[
    \(F \((z)\)\  = \ \(\(-\(z\/\(\(-1\) + z + 
              z\^2\)\)\)\(\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \)\)\)], "Input",
  TextAlignment->Left,
  TextJustification->0],

Cell["(is in fact the well known Fibonacci generating function)", "Text",
  CellMargins->{{54, Inherited}, {Inherited, Inherited}}],

Cell[BoxData[
    \(H \((z)\)\  = \ \(-\(\(z\ \((1 + z)\)\)\/\(\(-1\) + z + 
              z\^2\)\)\)\)], "Input",
  TextAlignment->Left,
  TextJustification->0],

Cell["\[DoubleDownArrow]", "Text",
  CellMargins->{{24.3125, Inherited}, {Inherited, Inherited}},
  GeneratedCell->True],

Cell[TextData[{
  "  Closed\[Dash]form of the coefficients (",
  StyleBox["Rational Expansion Theorem for Distinct Roots",
    FontSlant->"Italic",
    FontColor->RGBColor[1, 0, 0]],
  "):"
}], "Text",
  TextAlignment->Left,
  TextJustification->0,
  FontWeight->"Bold"],

Cell[BoxData[
    \(F\_n = \ \(\(\[Phi]\^n\) \[Dash]\ \[Phi]\&^\^n\)\/\^\(\@5\)\ \ \ \ \ \ \
\ \ \ \ \ \ \ \ \ \ \ \ \  \[Implies] \ \(n\^\(\(th\)\(\ \)\)\) 
          Fibonacci\ number\)], "Input",
  TextAlignment->Left,
  TextJustification->0],

Cell[BoxData[
    \(H\_n = \ \(\(\[Phi]\^\(n + 1\)\) \[Dash]\ \[Phi]\&^\^\(n + \
1\)\)\/\^\(\@5\)\ \ \ \ \ \ \ \ \ \ \  \[Implies] \ \(\((n + 
                  1)\)\^\(\(th\)\(\ \)\)\) Fibonacci\ number\)], "Input",
  TextAlignment->Left,
  TextJustification->0],

Cell[BoxData[
    \(\(\(\ \ \ \ \ \ \ \ \ \ \)\((where : \ \ \ \[Phi]\  = \ \(1\  + \ \@5\)\
\/2)\)\)\)], "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Verification Conditions",
  FontWeight->"Bold",
  FontColor->RGBColor[0.137255, 0.435294, 0.0745098]]], "Text",
  FontColor->RGBColor[0, 0.449226, 0]],

Cell[CellGroupData[{

Cell[BoxData[
    \(VCG[Program["\<Fibonacci\>"], 
      Specification["\<Fibonacci\>"]]\)], "Input"],

Cell[BoxData[
    FormBox[
      RowBox[{
      "Lemma", \(\(\ \)\((\)\), "Fibonacci", \(\()\)\(:\)\(\n\)\), GridBox[{
            {
              RowBox[{\(for\ \(\(any\)\(:\)\)\), 
                RowBox[{
                  StyleBox["n",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], ",", 
                  StyleBox["F",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], ",", "H", ",", "i"}]}]}
            },
          ColumnAlignments->{Left}], "\n", 
        RowBox[{
          RowBox[{\((WHILE . Inv + Term)\), "\t", 
            RowBox[{
              RowBox[{
                RowBox[{"(", 
                  RowBox[{"H", "=", 
                    RowBox[{
                      RowBox[{
                        
                        SuperscriptBox[\((1\/2*\((1 + \
\((\(-1\))\)*5\^\(1\/2\))\))\), 
                          RowBox[{"1", "+", \(\((\(-1\))\)*i\), "+", 
                            StyleBox["n",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None]}]], 
                        "*", \(\((\(-5\) + 5\^\(1\/2\))\)\^\(-1\)\), 
                        "*", \((\(-3\) + 5\^\(1\/2\))\)}], "+", 
                      RowBox[{
                        
                        SuperscriptBox[\((2*\((1 + 5\^\(1\/2\))\)\^\(-1\))\), 
                          
                          RowBox[{\(-1\), "+", "i", "+", 
                            RowBox[{\((\(-1\))\), "*", 
                              StyleBox["n",
                                FontWeight->"Bold",
                                FontSlant->"Italic",
                                FontColor->RGBColor[0, 0, 1],
                                Background->None]}]}]], 
                        "*", \((3 + 5\^\(1\/2\))\), 
                        "*", \(\((5 + 5\^\(1\/2\))\)\^\(-1\)\)}]}]}], ")"}], 
                "\[And]", 
                RowBox[{"(", 
                  RowBox[{
                    StyleBox["F",
                      FontWeight->"Bold",
                      FontSlant->"Italic",
                      FontColor->RGBColor[0, 0, 1],
                      Background->None], "=", 
                    RowBox[{
                      RowBox[{
                        
                        SuperscriptBox[\((1\/2*\((1 + \
\((\(-1\))\)*5\^\(1\/2\))\))\), 
                          RowBox[{"1", "+", \(\((\(-1\))\)*i\), "+", 
                            StyleBox["n",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None]}]], 
                        "*", \(\((\(-5\) + 5\^\(1\/2\))\)\^\(-1\)\), 
                        "*", \((\(-1\) + 5\^\(1\/2\))\)}], "+", 
                      RowBox[{
                        SuperscriptBox["2", 
                          RowBox[{\(-1\), "+", "i", "+", 
                            RowBox[{\((\(-1\))\), "*", 
                              StyleBox["n",
                                FontWeight->"Bold",
                                FontSlant->"Italic",
                                FontColor->RGBColor[0, 0, 1],
                                Background->None]}]}]], "*", 
                        SuperscriptBox[\((1 + 5\^\(1\/2\))\), 
                          RowBox[{"2", "+", \(\((\(-1\))\)*i\), "+", 
                            StyleBox["n",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None]}]], 
                        "*", \(\((5 + 5\^\(1\/2\))\)\^\(-1\)\)}]}]}], ")"}], 
                "\[And]", \(i > 1\), "\[And]", \((T1 := \(-1\) + i)\)}], 
              "\[Implies]", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"H", "+", 
                      StyleBox["F",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None]}], "=", 
                    RowBox[{
                      RowBox[{
                        
                        SuperscriptBox[\((1\/2*\((1 + \
\((\(-1\))\)*5\^\(1\/2\))\))\), 
                          RowBox[{"2", "+", \(\((\(-1\))\)*i\), "+", 
                            StyleBox["n",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None]}]], 
                        "*", \(\((\(-5\) + 5\^\(1\/2\))\)\^\(-1\)\), 
                        "*", \((\(-3\) + 5\^\(1\/2\))\)}], "+", 
                      RowBox[{
                        
                        SuperscriptBox[\((2*\((1 + 5\^\(1\/2\))\)\^\(-1\))\), 
                          
                          RowBox[{\(-2\), "+", "i", "+", 
                            RowBox[{\((\(-1\))\), "*", 
                              StyleBox["n",
                                FontWeight->"Bold",
                                FontSlant->"Italic",
                                FontColor->RGBColor[0, 0, 1],
                                Background->None]}]}]], 
                        "*", \((3 + 5\^\(1\/2\))\), 
                        "*", \(\((5 + 5\^\(1\/2\))\)\^\(-1\)\)}]}]}], ")"}], 
                "\[And]", 
                RowBox[{"(", 
                  RowBox[{"H", "=", 
                    RowBox[{
                      RowBox[{
                        
                        SuperscriptBox[\((1\/2*\((1 + \
\((\(-1\))\)*5\^\(1\/2\))\))\), 
                          RowBox[{"2", "+", \(\((\(-1\))\)*i\), "+", 
                            StyleBox["n",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None]}]], 
                        "*", \(\((\(-5\) + 5\^\(1\/2\))\)\^\(-1\)\), 
                        "*", \((\(-1\) + 5\^\(1\/2\))\)}], "+", 
                      RowBox[{
                        SuperscriptBox["2", 
                          RowBox[{\(-2\), "+", "i", "+", 
                            RowBox[{\((\(-1\))\), "*", 
                              StyleBox["n",
                                FontWeight->"Bold",
                                FontSlant->"Italic",
                                FontColor->RGBColor[0, 0, 1],
                                Background->None]}]}]], "*", 
                        SuperscriptBox[\((1 + 5\^\(1\/2\))\), 
                          RowBox[{"3", "+", \(\((\(-1\))\)*i\), "+", 
                            StyleBox["n",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None]}]], 
                        "*", \(\((5 + 5\^\(1\/2\))\)\^\(-1\)\)}]}]}], ")"}], 
                "\[And]", \(\(-2\) + i < T1\)}]}]}], "\n", 
          RowBox[{\((WHILE . Final)\), "\t", 
            RowBox[{
              RowBox[{
                RowBox[{"(", 
                  RowBox[{"H", "=", 
                    RowBox[{
                      RowBox[{
                        
                        SuperscriptBox[\((1\/2*\((1 + \
\((\(-1\))\)*5\^\(1\/2\))\))\), 
                          RowBox[{"1", "+", \(\((\(-1\))\)*i\), "+", 
                            StyleBox["n",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None]}]], 
                        "*", \(\((\(-5\) + 5\^\(1\/2\))\)\^\(-1\)\), 
                        "*", \((\(-3\) + 5\^\(1\/2\))\)}], "+", 
                      RowBox[{
                        
                        SuperscriptBox[\((2*\((1 + 5\^\(1\/2\))\)\^\(-1\))\), 
                          
                          RowBox[{\(-1\), "+", "i", "+", 
                            RowBox[{\((\(-1\))\), "*", 
                              StyleBox["n",
                                FontWeight->"Bold",
                                FontSlant->"Italic",
                                FontColor->RGBColor[0, 0, 1],
                                Background->None]}]}]], 
                        "*", \((3 + 5\^\(1\/2\))\), 
                        "*", \(\((5 + 5\^\(1\/2\))\)\^\(-1\)\)}]}]}], ")"}], 
                "\[And]", 
                RowBox[{"(", 
                  RowBox[{
                    StyleBox["F",
                      FontWeight->"Bold",
                      FontSlant->"Italic",
                      FontColor->RGBColor[0, 0, 1],
                      Background->None], "=", 
                    RowBox[{
                      RowBox[{
                        
                        SuperscriptBox[\((1\/2*\((1 + \
\((\(-1\))\)*5\^\(1\/2\))\))\), 
                          RowBox[{"1", "+", \(\((\(-1\))\)*i\), "+", 
                            StyleBox["n",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None]}]], 
                        "*", \(\((\(-5\) + 5\^\(1\/2\))\)\^\(-1\)\), 
                        "*", \((\(-1\) + 5\^\(1\/2\))\)}], "+", 
                      RowBox[{
                        SuperscriptBox["2", 
                          RowBox[{\(-1\), "+", "i", "+", 
                            RowBox[{\((\(-1\))\), "*", 
                              StyleBox["n",
                                FontWeight->"Bold",
                                FontSlant->"Italic",
                                FontColor->RGBColor[0, 0, 1],
                                Background->None]}]}]], "*", 
                        SuperscriptBox[\((1 + 5\^\(1\/2\))\), 
                          RowBox[{"2", "+", \(\((\(-1\))\)*i\), "+", 
                            StyleBox["n",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None]}]], 
                        "*", \(\((5 + 5\^\(1\/2\))\)\^\(-1\)\)}]}]}], ")"}], 
                "\[And]", \((i \[NotGreater] 1)\)}], "\[Implies]", 
              RowBox[{"(", 
                RowBox[{
                  StyleBox["F",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], "=", 
                  RowBox[{"FibExp", "[", 
                    StyleBox["n",
                      FontWeight->"Bold",
                      FontSlant->"Italic",
                      FontColor->RGBColor[0, 0, 1],
                      Background->None], "]"}]}], ")"}]}]}], "\n", 
          RowBox[{\((WHILE . Term)\), "\t", 
            RowBox[{
              RowBox[{
                RowBox[{"(", 
                  RowBox[{"H", "=", 
                    RowBox[{
                      RowBox[{
                        
                        SuperscriptBox[\((1\/2*\((1 + \
\((\(-1\))\)*5\^\(1\/2\))\))\), 
                          RowBox[{"1", "+", \(\((\(-1\))\)*i\), "+", 
                            StyleBox["n",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None]}]], 
                        "*", \(\((\(-5\) + 5\^\(1\/2\))\)\^\(-1\)\), 
                        "*", \((\(-3\) + 5\^\(1\/2\))\)}], "+", 
                      RowBox[{
                        
                        SuperscriptBox[\((2*\((1 + 5\^\(1\/2\))\)\^\(-1\))\), 
                          
                          RowBox[{\(-1\), "+", "i", "+", 
                            RowBox[{\((\(-1\))\), "*", 
                              StyleBox["n",
                                FontWeight->"Bold",
                                FontSlant->"Italic",
                                FontColor->RGBColor[0, 0, 1],
                                Background->None]}]}]], 
                        "*", \((3 + 5\^\(1\/2\))\), 
                        "*", \(\((5 + 5\^\(1\/2\))\)\^\(-1\)\)}]}]}], ")"}], 
                "\[And]", 
                RowBox[{"(", 
                  RowBox[{
                    StyleBox["F",
                      FontWeight->"Bold",
                      FontSlant->"Italic",
                      FontColor->RGBColor[0, 0, 1],
                      Background->None], "=", 
                    RowBox[{
                      RowBox[{
                        
                        SuperscriptBox[\((1\/2*\((1 + \
\((\(-1\))\)*5\^\(1\/2\))\))\), 
                          RowBox[{"1", "+", \(\((\(-1\))\)*i\), "+", 
                            StyleBox["n",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None]}]], 
                        "*", \(\((\(-5\) + 5\^\(1\/2\))\)\^\(-1\)\), 
                        "*", \((\(-1\) + 5\^\(1\/2\))\)}], "+", 
                      RowBox[{
                        SuperscriptBox["2", 
                          RowBox[{\(-1\), "+", "i", "+", 
                            RowBox[{\((\(-1\))\), "*", 
                              StyleBox["n",
                                FontWeight->"Bold",
                                FontSlant->"Italic",
                                FontColor->RGBColor[0, 0, 1],
                                Background->None]}]}]], "*", 
                        SuperscriptBox[\((1 + 5\^\(1\/2\))\), 
                          RowBox[{"2", "+", \(\((\(-1\))\)*i\), "+", 
                            StyleBox["n",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None]}]], 
                        "*", \(\((5 + 5\^\(1\/2\))\)\^\(-1\)\)}]}]}], ")"}], 
                "\[And]", \(i > 1\)}], 
              "\[Implies]", \(\(-1\) + i \[GreaterEqual] 0\)}]}], "\n", 
          RowBox[{\((Init)\), "\t", 
            RowBox[{
              RowBox[{
                StyleBox["n",
                  FontWeight->"Bold",
                  FontSlant->"Italic",
                  FontColor->RGBColor[0, 0, 1],
                  Background->None], ">", "0"}], 
              "\[Implies]", \(\((1 = 
                    1\/2*\((1 + \((\(-1\))\)*5\^\(1\/2\))\)*\((\(-5\) + \
5\^\(1\/2\))\)\^\(-1\)*\((\(-3\) + 5\^\(1\/2\))\) + 
                      1\/2*\((1 + 5\^\(1\/2\))\)*\((3 + 
                            5\^\(1\/2\))\)*\((5 + 5\^\(1\/2\))\)\^\(-1\))\) \
\[And] \((1 = 
                    1\/2*\((1 + \((\(-1\))\)*5\^\(1\/2\))\)*\((\(-5\) + \
5\^\(1\/2\))\)\^\(-1\)*\((\(-1\) + 5\^\(1\/2\))\) + 
                      1\/2*\((1 + 5\^\(1\/2\))\)\^2*\((5 + \
5\^\(1\/2\))\)\^\(-1\))\)\)}]}]}]}], TraditionalForm]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

\
\>", "Text",
  FontSize->2],

Cell[CellGroupData[{

Cell["While Loops (with Verification of Termination)", "Subsubsection"],

Cell[TextData[{
  "\t{P} ",
  StyleBox["while",
    FontVariations->{"Underline"->True}],
  " C ",
  StyleBox["do",
    FontVariations->{"Underline"->True}],
  " S ",
  StyleBox["endwhile ",
    FontVariations->{"Underline"->True}],
  "{Q},"
}], "Text",
  CellMargins->{{38, Inherited}, {Inherited, Inherited}}],

Cell["where S is a program and C is a predicate", "Text",
  CellMargins->{{78, Inherited}, {Inherited, Inherited}}],

Cell["if:", "Text"],

Cell["\t(WT1) P \[Implies] I", "Text",
  CellMargins->{{38, Inherited}, {Inherited, Inherited}}],

Cell["\<\
(WT2) (I \[Wedge] C)  \[Implies]   T \[Element] \[DoubleStruckCapitalN]
(or T\[Element]\[DoubleStruckCapitalD], where \[DoubleStruckCapitalD] is any \
domain with a relation of order denoted by < )\
\>", "Text",
  CellMargins->{{74, Inherited}, {Inherited, Inherited}}],

Cell[TextData[{
  "\t(WT3) {I \[Wedge] C \[Wedge] (T= ",
  Cell[BoxData[
      \(TraditionalForm\`T\_1\)]],
  ")} S {I \[Wedge] (T < ",
  Cell[BoxData[
      \(TraditionalForm\`T\_1\)]],
  ")}  "
}], "Text",
  CellMargins->{{38, Inherited}, {Inherited, Inherited}}],

Cell["\t(WT4) (I \[Wedge] \[Not]C) \[Implies] Q.", "Text",
  CellMargins->{{38, Inherited}, {Inherited, Inherited}}],

Cell[TextData[{
  "where I is a Loop-Invariant, T is a Termination Term and  ",
  Cell[BoxData[
      \(TraditionalForm\`T\_1\)]],
  " is a new variable. "
}], "Text",
  CellMargins->{{78, Inherited}, {Inherited, Inherited}}],

Cell[TextData[{
  "remark:",
  StyleBox[" These verification rules allow us to prove the termination of \
the program.",
    FontSlant->"Plain"]
}], "Text",
  FontSlant->"Italic"],

Cell["Example:", "Text",
  FontSlant->"Italic"],

Cell[BoxData[{
    FormBox[
      StyleBox[\({r = \(x\[Wedge]q = 0\)}\),
        FontWeight->"Plain",
        FontSlant->"Plain",
        FontTracking->"Plain",
        FontVariations->{"Underline"->False,
        "Outline"->False,
        "Shadow"->False,
        "StrikeThrough"->False,
        "Masked"->False,
        "CompatibilityType"->0,
        "RotationAngle"->0}], TraditionalForm], "\[IndentingNewLine]", 
    FormBox[
      RowBox[{
        StyleBox["while",
          FontWeight->"Plain",
          FontSlant->"Plain",
          FontTracking->"Plain",
          FontVariations->{"Underline"->True,
          "Outline"->False,
          "Shadow"->False,
          "StrikeThrough"->False,
          "Masked"->False,
          "CompatibilityType"->0,
          "RotationAngle"->0}], 
        StyleBox[" ",
          FontWeight->"Plain",
          FontSlant->"Plain",
          FontTracking->"Plain",
          FontVariations->{"Underline"->False,
          "Outline"->False,
          "Shadow"->False,
          "StrikeThrough"->False,
          "Masked"->False,
          "CompatibilityType"->0,
          "RotationAngle"->0}], 
        RowBox[{"(", 
          StyleBox[\(y \[LessEqual] r\),
            FontWeight->"Plain",
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontVariations->{"Underline"->False,
            "Outline"->False,
            "Shadow"->False,
            "StrikeThrough"->False,
            "Masked"->False,
            "CompatibilityType"->0,
            "RotationAngle"->0}], 
          StyleBox[")",
            FontWeight->"Plain",
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontVariations->{"Underline"->False,
            "Outline"->False,
            "Shadow"->False,
            "StrikeThrough"->False,
            "Masked"->False,
            "CompatibilityType"->0,
            "RotationAngle"->0}]}], 
        StyleBox["do",
          FontWeight->"Plain",
          FontSlant->"Plain",
          FontTracking->"Plain",
          FontVariations->{"Underline"->True,
          "Outline"->False,
          "Shadow"->False,
          "StrikeThrough"->False,
          "Masked"->False,
          "CompatibilityType"->0,
          "RotationAngle"->0}]}], TraditionalForm], "\[IndentingNewLine]", 
    FormBox[
      StyleBox[\(\(\ \ \ \ \ \ \ \ \)\(r := r - y;\)\),
        FontWeight->"Plain",
        FontSlant->"Plain",
        FontTracking->"Plain",
        FontVariations->{"Underline"->False,
        "Outline"->False,
        "Shadow"->False,
        "StrikeThrough"->False,
        "Masked"->False,
        "CompatibilityType"->0,
        "RotationAngle"->0}], TraditionalForm], "\[IndentingNewLine]", 
    FormBox[
      RowBox[{"        ", 
        StyleBox[\(q := q + 1\),
          FontWeight->"Plain",
          FontSlant->"Plain",
          FontTracking->"Plain",
          FontVariations->{"Underline"->False,
          "Outline"->False,
          "Shadow"->False,
          "StrikeThrough"->False,
          "Masked"->False,
          "CompatibilityType"->0,
          "RotationAngle"->0}]}], TraditionalForm], "\[IndentingNewLine]", 
    FormBox[
      RowBox[{
        StyleBox["endwhile",
          FontWeight->"Plain",
          FontSlant->"Plain",
          FontTracking->"Plain",
          FontVariations->{"Underline"->True,
          "Outline"->False,
          "Shadow"->False,
          "StrikeThrough"->False,
          "Masked"->False,
          "CompatibilityType"->0,
          "RotationAngle"->0}], 
        StyleBox[" ",
          FontWeight->"Plain",
          FontSlant->"Plain",
          FontTracking->"Plain",
          FontVariations->{"Underline"->False,
          "Outline"->False,
          "Shadow"->False,
          "StrikeThrough"->False,
          "Masked"->False,
          "CompatibilityType"->0,
          "RotationAngle"->0}]}], TraditionalForm], "\[IndentingNewLine]", 
    FormBox[
      StyleBox[\({r + y*q = x\  \[And] \ r < y}\),
        FontWeight->"Plain",
        FontSlant->"Plain",
        FontTracking->"Plain",
        FontVariations->{"Underline"->False,
        "Outline"->False,
        "Shadow"->False,
        "StrikeThrough"->False,
        "Masked"->False,
        "CompatibilityType"->0,
        "RotationAngle"->0}], TraditionalForm]}], "Input",
  CellMargins->{{71, Inherited}, {Inherited, Inherited}}],

Cell[TextData[{
  " where we choose as :\n\n -  Termination term: T  \[Congruent]   r-y \n\n \
-  Loop-Invariant: ",
  Cell[BoxData[
      FormBox[
        RowBox[{"   ", 
          StyleBox[\(I\ \  \[Congruent] \ \ r + y*q\  = \ x\),
            FontWeight->"Plain",
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontVariations->{"Underline"->False,
            "Outline"->False,
            "Shadow"->False,
            "StrikeThrough"->False,
            "Masked"->False,
            "CompatibilityType"->0,
            "RotationAngle"->0}]}], TraditionalForm]]]
}], "Text",
  CellMargins->{{70, Inherited}, {Inherited, Inherited}}],

Cell["\<\

 produces the following verification conditions:\
\>", "Text"],

Cell[BoxData[
    FormBox[
      RowBox[{
        RowBox[{\((WT1)\), " ", 
          StyleBox[\((r = \(x\[Wedge]q = 0\))\),
            FontWeight->"Plain",
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontVariations->{"Underline"->False,
            "Outline"->False,
            "Shadow"->False,
            "StrikeThrough"->False,
            "Masked"->False,
            "CompatibilityType"->0,
            "RotationAngle"->0}]}], 
        StyleBox["\[Implies]",
          FontWeight->"Plain",
          FontSlant->"Plain",
          FontTracking->"Plain",
          FontVariations->{"Underline"->False,
          "Outline"->False,
          "Shadow"->False,
          "StrikeThrough"->False,
          "Masked"->False,
          "CompatibilityType"->0,
          "RotationAngle"->0}], 
        StyleBox[\((r + y*q = x)\),
          FontWeight->"Plain",
          FontSlant->"Plain",
          FontTracking->"Plain",
          FontVariations->{"Underline"->False,
          "Outline"->False,
          "Shadow"->False,
          "StrikeThrough"->False,
          "Masked"->False,
          "CompatibilityType"->0,
          "RotationAngle"->0}]}], TraditionalForm]], "Input",
  CellMargins->{{76, Inherited}, {Inherited, Inherited}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell[BoxData[
    FormBox[
      StyleBox[\(\((WT2)\)\ \((\((r + y*q = x)\)\[Wedge]\((y \[LessEqual] 
                    r)\))\) \[Implies] \((r - 
                y)\) \[Element] \[DoubleStruckCapitalN]\),
        FontWeight->"Plain",
        FontSlant->"Plain",
        FontTracking->"Plain",
        FontVariations->{"Underline"->False,
        "Outline"->False,
        "Shadow"->False,
        "StrikeThrough"->False,
        "Masked"->False,
        "CompatibilityType"->0,
        "RotationAngle"->0}], TraditionalForm]], "Input",
  CellMargins->{{77, Inherited}, {Inherited, Inherited}}],

Cell[BoxData[{
    StyleBox[
      RowBox[{\((WT3)\), " ", 
        RowBox[{"{", 
          
          RowBox[{\(\((r + y*q = x)\)\[Wedge]\((y \[LessEqual] 
                  r)\)\[Wedge]\((r - y)\)\), "=", 
            FormBox[
              StyleBox[\(T\_1\),
                FontFamily->"Times New Roman CE"],
              "TraditionalForm"]}], "}"}]}],
      FontWeight->"Plain",
      FontSlant->"Plain",
      FontTracking->"Plain",
      FontVariations->{"Underline"->False,
      "Outline"->False,
      "Shadow"->False,
      "StrikeThrough"->False,
      "Masked"->False,
      "CompatibilityType"->0,
      "RotationAngle"->0}], "\[IndentingNewLine]", 
    StyleBox[\(\(\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \)\(r := r - y;\)\(\ \)\),
      FontWeight->"Plain",
      FontSlant->"Plain",
      FontTracking->"Plain",
      FontVariations->{"Underline"->False,
      "Outline"->False,
      "Shadow"->False,
      "StrikeThrough"->False,
      "Masked"->False,
      "CompatibilityType"->0,
      "RotationAngle"->0}], "\[IndentingNewLine]", 
    StyleBox[\(\(\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \)\(q := q + 1\)\(\ \)\),
      FontWeight->"Plain",
      FontSlant->"Plain",
      FontTracking->"Plain",
      FontVariations->{"Underline"->False,
      "Outline"->False,
      "Shadow"->False,
      "StrikeThrough"->False,
      "Masked"->False,
      "CompatibilityType"->0,
      "RotationAngle"->0}], "\[IndentingNewLine]", 
    RowBox[{
      StyleBox["              ",
        FontWeight->"Plain",
        FontSlant->"Plain",
        FontTracking->"Plain",
        FontVariations->{"Underline"->False,
        "Outline"->False,
        "Shadow"->False,
        "StrikeThrough"->False,
        "Masked"->False,
        "CompatibilityType"->0,
        "RotationAngle"->0}], 
      RowBox[{
        StyleBox["{",
          FontWeight->"Plain",
          FontSlant->"Plain",
          FontTracking->"Plain",
          FontVariations->{"Underline"->False,
          "Outline"->False,
          "Shadow"->False,
          "StrikeThrough"->False,
          "Masked"->False,
          "CompatibilityType"->0,
          "RotationAngle"->0}], 
        RowBox[{
          StyleBox[\(\((r + y*q = x)\)\[Wedge]\((r - y)\)\),
            FontWeight->"Plain",
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontVariations->{"Underline"->False,
            "Outline"->False,
            "Shadow"->False,
            "StrikeThrough"->False,
            "Masked"->False,
            "CompatibilityType"->0,
            "RotationAngle"->0}], 
          StyleBox["<",
            FontFamily->"Times New Roman CE",
            FontWeight->"Plain",
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontVariations->{"Underline"->False,
            "Outline"->False,
            "Shadow"->False,
            "StrikeThrough"->False,
            "Masked"->False,
            "CompatibilityType"->0,
            "RotationAngle"->0}], 
          StyleBox[
            FormBox[\(T\_1\),
              "TraditionalForm"],
            FontFamily->"Times New Roman CE",
            FontWeight->"Plain",
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontVariations->{"Underline"->False,
            "Outline"->False,
            "Shadow"->False,
            "StrikeThrough"->False,
            "Masked"->False,
            "CompatibilityType"->0,
            "RotationAngle"->0}]}], 
        StyleBox["}",
          FontFamily->"Times New Roman CE",
          FontWeight->"Plain",
          FontSlant->"Plain",
          FontTracking->"Plain",
          FontVariations->{"Underline"->False,
          "Outline"->False,
          "Shadow"->False,
          "StrikeThrough"->False,
          "Masked"->False,
          "CompatibilityType"->0,
          "RotationAngle"->0}]}]}]}], "Input",
  CellMargins->{{76, Inherited}, {Inherited, Inherited}},
  FontFamily->"Times New Roman CE"],

Cell[BoxData[
    FormBox[
      RowBox[{
        RowBox[{\((WT4)\), " ", 
          
          StyleBox[\((\((r + y*q = 
                    x)\)\[Wedge]\(\[Not] \((y \[LessEqual] r)\)\))\),
            FontWeight->"Plain",
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontVariations->{"Underline"->False,
            "Outline"->False,
            "Shadow"->False,
            "StrikeThrough"->False,
            "Masked"->False,
            "CompatibilityType"->0,
            "RotationAngle"->0}]}], "\[Implies]", 
        StyleBox[\((r + y*q = x\[Wedge]r < y)\),
          FontWeight->"Plain",
          FontSlant->"Plain",
          FontTracking->"Plain",
          FontVariations->{"Underline"->False,
          "Outline"->False,
          "Shadow"->False,
          "StrikeThrough"->False,
          "Masked"->False,
          "CompatibilityType"->0,
          "RotationAngle"->0}]}], TraditionalForm]], "Input",
  CellMargins->{{76, Inherited}, {Inherited, Inherited}},
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0}],

Cell[TextData[{
  "remark:",
  StyleBox[" in the case of y=0, the proof of (WT3) will fail \[Implies] \
non-termination",
    FontSlant->"Plain"]
}], "Text",
  FontSlant->"Italic"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[TextData[Cell[BoxData[GridBox[{
        {
          ButtonBox[
            StyleBox["\[FirstPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageFirst"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"First Slide"], 
          ButtonBox[
            StyleBox["\[LeftPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPagePrevious"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Previous Slide"], 
          ButtonBox[
            StyleBox["\[RightPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageNext"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Next Slide"], 
          ButtonBox[
            StyleBox["\[LastPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageLast"]}],
            ButtonStyle->"SlideHyperlink"], " ", 
          ButtonBox[
            StyleBox[
              RowBox[{
                CounterBox["SlideShowNavigationBar"], \(\(\ \)\(of\)\(\ \)\), 
                
                
                CounterBox["SlideShowNavigationBar", {None, 
                  "SlideShowHeader", -1}]}],
              "SR"],
            ButtonFrame->"None"]}
        }]]]], "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["Invariant Generation for Loops with ",
    FontFamily->"Times New Roman"],
  StyleBox["Conditionals",
    FontFamily->"Times New Roman"]
}], "Section",
  CellDingbat->"\[DiamondSuit]",
  CellMargins->{{21.3125, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0,
  FontColor->RGBColor[0.137255, 0.435294, 0.0745098]],

Cell[CellGroupData[{

Cell["Example: Wensley Algorithm for Real Division", "Subsection",
  CellDingbat->None,
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  FontSize->24],

Cell[BoxData[
    \(Specification["\<ReDiv\>", 
      ReDiv[\(\(\[DownArrow]\)\(P\)\), \(\(\[DownArrow]\)\(Q\)\), \(\(\
\[DownArrow]\)\(Tol\)\), \(\(\[UpArrow]\)\(r\)\)], \[IndentingNewLine]Pre \
\[Rule] \((\((\ 
              IsReal[P]\  \[And] \ IsReal[Q]\  \[And] \ 
                IsReal[Tol])\)\  \[And] \ \((Q > 
                P)\)\  \[And] \ \((P \[GreaterEqual] 0)\)\  \[And] \ \((Tol > 
                0)\))\), \[IndentingNewLine]Post \[Rule] \((\((P/Q\  < 
                r + Tol)\)\  \[And] \ \((r \[LessEqual] 
                P/Q)\))\)\[IndentingNewLine]]\)], "Input",
  CellLabel->"TS_In[263]:="],

Cell[BoxData[
    \(Program["\<ReDiv\>", 
      ReDiv[\(\(\[DownArrow]\)\(P\)\), \(\(\[DownArrow]\)\(Q\)\), \(\(\
\[DownArrow]\)\(Tol\)\), \(\(\[UpArrow]\)\(r\)\)], \
\[IndentingNewLine]Module[{a, b, d, y}, \[IndentingNewLine]\t
        a := 0; \[IndentingNewLine]\tb := Q/2; \[IndentingNewLine]\t
        d := 1; \[IndentingNewLine]\ty := 0; \[IndentingNewLine]\t
        WHILE[d \[GreaterEqual] Tol, \[IndentingNewLine]\t\t\tIF[
            P < a + b, \[IndentingNewLine]\t\t\t\t\tb := b/2; 
            d := d/2, \[IndentingNewLine]\t\t\t\t\ta := a + b; y := y + d/2; 
            b := b/2; 
            d := d/2\[IndentingNewLine]\t\t\t], \[IndentingNewLine]\t\tAssert \
\[Rule] \((y \[LessEqual] P/Q < y + d)\) \[And] \ \((0 < d \[LessEqual] 
                  1)\), \[IndentingNewLine]\t\tTerminationTerm \[Rule] 
            d - Tol\[IndentingNewLine]\t]; \[IndentingNewLine]r := 
          y\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input",
  CellLabel->"TS_In[264]:="],

Cell[CellGroupData[{

Cell[TextData[StyleBox["The Algorithm:",
  FontSlant->"Italic"]], "Subsection",
  CellDingbat->None,
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  FontSize->24],

Cell[CellGroupData[{

Cell["\<\
Program Transformation \[Rule] Loops with only assignments\
\>", "Subsubsection",
  CellDingbat->None,
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  FontSize->18],

Cell["Used Rule:", "Text",
  CellMargins->{{37.3125, Inherited}, {Inherited, Inherited}}],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{\((WR)\), "           ", 
      FractionBox[GridBox[{
            {\({I \[And] b}\[IndentingNewLine]
              
              WHILE[c, \[IndentingNewLine]\t
                WHILE[c\  \[And] b', \[IndentingNewLine]\t\t\ s1; s2; 
                  s4]; \[IndentingNewLine]\t
                WHILE[c \[And] \[Not] b', \[IndentingNewLine]\t\t\ \ s1; s3; 
                  s4]]\), \(\({I \[And] \[Not] b}\)\(\[IndentingNewLine]\)
              \(WHILE[c, \[IndentingNewLine]\t
                WHILE[c \[And] \[Not] b', \[IndentingNewLine]\t\t\ s1; s3; 
                  s4]; \[IndentingNewLine]\t
                WHILE[c \[And] b', \[IndentingNewLine]\t\t\ \ s1; s2; 
                  s4]]\)\(\ \ \ \ \ \ \ \ \ \ \ \)\)},
            {\(\({I \[And] \[Not] c}\)\(\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \ \ \ \ \ \ \ \)\), \(\({I \[And] \[Not] c}\)\(\ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \)\)}
            }], \({I} 
          WHILE[c, s1; IF[b, s2; s3]; s4] {I \[And] \[Not] c}\)]}]], "Input",
  CellMargins->{{99.625, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0],

Cell["\<\
where:
- I is the invariant of the original WHILE (i.e. While with conditionals). It \
is assumed that the inner WHILEs have as invariant I;
- b' denotes the condition b modified by the assignment statement(s) s1  \
(i.e. b' denotes condition b after its variables are updates by their new \
values given by the assignemnt statement(s) s1);\
\>", "Text"],

Cell[BoxData[GridBox[{
        {\(\(WHILE[d \[GreaterEqual] Tol, \[IndentingNewLine]\t
            WHILE[P < a + b\  \[And] \ 
                d \[GreaterEqual] Tol, \[IndentingNewLine]\t\t\tb := b/2; 
              d := d/2]; \[IndentingNewLine]\t
            WHILE[P \[NotLess] a + b\  \[And] \ 
                d \[GreaterEqual] Tol, \[IndentingNewLine]\t\t\ta := a + b; 
              y := y + d/2; \[IndentingNewLine]\t\t\tb := b/2; 
              d := d/2]\[IndentingNewLine]\t]\)\(\[IndentingNewLine]\)\(\
\[IndentingNewLine]\)
          \), \(WHILE[d \[GreaterEqual] Tol, \[IndentingNewLine]\t
            WHILE[P \[NotLess] a + b\  \[And] 
                d \[GreaterEqual] Tol, \[IndentingNewLine]\t\t\ta := a + b; 
              y := y + d/2; \[IndentingNewLine]\t\t\tb := b/2; 
              d := d/2]; \[IndentingNewLine]\t
            WHILE[P < a + b\  \[And] \ 
                d \[GreaterEqual] Tol, \[IndentingNewLine]\t\t\tb := b/2; 
              d := d/2];\[IndentingNewLine]\t]\)}
        }]], "Input"]
}, Open  ]],

Cell["\<\
Proof: Soundness proof  of a simpler version of (WR) can be found in \
AppendixWhileRule.pdf\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "Recurrence solving -",
  StyleBox[" from combinatorics:",
    FontSize->14,
    FontColor->RGBColor[0.501961, 0, 0]]
}], "Subsubsection",
  CellDingbat->None,
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  FontSize->18],

Cell[BoxData[
    RowBox[{
      RowBox[{\((K)\), "  ", 
        RowBox[{
          StyleBox["{",
            SpanMaxSize->Infinity], GridBox[{
              {\(b\_K = b\_\(K - 1\)/2\)},
              {\(d\_K = d\_\(K - 1\)/2\)},
              {\(a\_K = a\_\(K - 1\)\)},
              {\(y\_K = y\_\(K - 1\)\)}
              },
            ColumnAlignments->{Left}], 
          StyleBox["}",
            ShowContents->False]}]}], " ", "\[Implies]", "  ", 
      RowBox[{
        StyleBox["{",
          SpanMaxSize->Infinity], GridBox[{
            {\(b\_K = b\_0/2\^K\)},
            {\(d\_K = d\_0/2\^K\)},
            {\(a\_K = a\_0\)},
            {\(y\_K = y\_0\)}
            },
          ColumnAlignments->{Left}], 
        StyleBox["}",
          ShowContents->False]}], " "}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{\((L)\), "  ", 
        RowBox[{
          StyleBox["{",
            SpanMaxSize->Infinity], GridBox[{
              {\(a\_L = a\_\(L - 1\) + b\_\(L - 1\)\)},
              {\(y\_L = y\_\(L - 1\) + d\_\(L - 1\)/2\)},
              {\(b\_L = b\_\(L - 1\)/2\)},
              {\(d\_L = d\_\(L - 1\)/2\)}
              },
            ColumnAlignments->{Left}], 
          StyleBox["}",
            ShowContents->False]}]}], " ", "\[Implies]", 
      RowBox[{
        StyleBox["{",
          SpanMaxSize->Infinity], GridBox[{
            {\(a\_L = a\_K + 2\ b\_K - \(2\^\(1 + \((\(-1\))\) L\)\) b\_K\)},
            {\(y\_L = y\_K + d\_K + \((\(-1\))\) \(2\^\(-L\)\) d\_K\)},
            {\(b\_L = b\_K/2\^L\)},
            {\(d\_L = d\_K/2\^L\)}
            },
          ColumnAlignments->{Left}], 
        StyleBox["}",
          ShowContents->False]}]}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Index manipulation ", "Subsubsection",
  CellDingbat->None,
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  FontSize->18],

Cell[BoxData[
    RowBox[{\((K, L)\), "  ", 
      RowBox[{
        StyleBox["{",
          SpanMaxSize->Infinity], GridBox[{
            {\(a\_L = 
                a\_0 + 2\^\(1 + \((\(-1\))\) K\)\ b\_0 - \(2\^\(1 + \
\((\(-1\))\) K + \((\(-1\))\) L\)\) b\_0\)},
            {\(y\_L = 
                y\_0 + \(d\_0\) 2\^\(-K\) + \((\(-1\))\) 
                    2\^\(\(-K\) + \((\(-1\))\) L\)\ d\_0\)},
            {\(b\_L = b\_0\ 2\^\(\(-K\) + \((\(-1\))\) L\)\)},
            {\(d\_L = \(d\_0\) 2\^\(\(-K\) + \((\(-1\))\) L\)\)}
            },
          ColumnAlignments->{Left}], 
        StyleBox["}",
          ShowContents->False]}]}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "Variable elimination ",
  StyleBox["(K, L)   -",
    FontSize->14],
  StyleBox[" ",
    FontSize->9],
  StyleBox["by algebraic solving techniques:",
    FontSize->14,
    FontColor->RGBColor[0.501961, 0, 0]]
}], "Subsubsection",
  CellDingbat->None,
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  FontSize->18],

Cell[BoxData[
    \({\(-b\) + \(d\ b\_0\)\/d\_0\  = \ 
        0, \[IndentingNewLine]\(-2\)\ y\ b\_0 + a\ d\_0 - a\_0\ d\_0 + 
          2\ b\_0\ y\_\(\(0\)\(\ \)\) = 
        0, \[IndentingNewLine]\[IndentingNewLine]\(-d\)\ b\_0 + b\ d\_0, 
      d\ \((\(-a\) + a\_0)\) + b\ \((2\ y - 2\ y\_0)\) = 
        0, \[IndentingNewLine]\[IndentingNewLine]\(-2\)\ b\_0 + \(\((a + 2\ b \
- a\_0)\)\ d\_0\)\/\(d + y - y\_0\) = 0}\)], "Input",
  CellLabel->"In[1]:="],

Cell[TextData[{
  "where we used : ",
  Cell[BoxData[
      \(TraditionalForm\`{a\_L \[Rule] a, \ b\_L \[Rule] b, \ 
        d\_L \[Rule] d, \ y\_L \[Rule] y}\)]]
}], "Text",
  CellMargins->{{37.3125, Inherited}, {Inherited, Inherited}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Invariance checking ", "Subsubsection",
  CellDingbat->None,
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  FontSize->18],

Cell["Possible loop iterations:", "Text",
  CellMargins->{{37.3125, Inherited}, {Inherited, Inherited}}],

Cell[BoxData[
    \({b \[Rule] b\/2, d \[Rule] d\/2}\)], "Input"],

Cell[BoxData[
    \({a \[Rule] a + b, y \[Rule] y + d\/2, b \[Rule] b\/2, 
      d \[Rule] d\/2}\)], "Input"],

Cell["Remaining Invariant Properties:", "Text",
  CellMargins->{{37.3125, Inherited}, {Inherited, Inherited}}],

Cell[BoxData[
    \({d\ \((\(-a\) + a\_0)\) + b\ \((2\ y - 2\ y\_0)\) = 
        0, \[IndentingNewLine]\[IndentingNewLine]\(-d\)\ b\_0 + b\ d\_0 = 
        0, \[IndentingNewLine]\[IndentingNewLine]\(-b\) + \(d\ b\_0\)\/d\_0 = 
        0}\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "Computing ",
  StyleBox["Groebner basis",
    FontColor->RGBColor[0.501961, 0, 0]],
  " (for polynomial relations)",
  StyleBox["  \nand initial value substitution",
    FontSize->14]
}], "Subsubsection",
  CellDingbat->None,
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  FontSize->18],

Cell[BoxData[
    \(\((1\/2*d*Q = b)\)\  \[And] \ \((a*d = d*y*Q)\)\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Conjunction of asserted and generated invariant properties", \
"Subsubsection",
  CellDingbat->None,
  CellMargins->{{36.625, Inherited}, {Inherited, Inherited}},
  FontSize->18],

Cell[BoxData[
    \(\((1\/2*d*Q = b)\)\  \[And] \ \((a*d = 
          d*y*Q)\)\  \[And] \ \((y \[LessEqual] P/Q < 
          y + d)\) \[And] \ \((0 < d \[LessEqual] 1)\)\)], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(VCG[Program["\<ReDiv\>"], Specification["\<ReDiv\>"]]\)], "Input",
  TextAlignment->Left,
  TextJustification->0],

Cell[BoxData[
    FormBox[
      RowBox[{
      "Lemma", \(\(\ \)\((\)\), "ReDiv", \(\()\)\(:\)\(\n\)\), GridBox[{
            {
              RowBox[{\(for\ \(\(any\)\(:\)\)\), 
                RowBox[{
                  StyleBox["P",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], ",", 
                  StyleBox["Q",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], ",", 
                  StyleBox["Tol",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], ",", 
                  StyleBox["r",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], ",", "a", ",", "b", ",", "d", ",", 
                  "y"}]}]}
            },
          ColumnAlignments->{Left}], "\n", 
        RowBox[{
          RowBox[{\((WHILE . Inv + Term)\), "\t", 
            RowBox[{
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{\(\(-1\)*b\), "+", 
                      RowBox[{\(1\/2\), "*", "d", "*", 
                        StyleBox["Q",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}]}], "=", "0"}], ")"}], "\[And]", 
                
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{\(a*d\), "+", 
                      RowBox[{\((\(-1\))\), "*", "d", "*", "y", "*", 
                        StyleBox["Q",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}]}], "=", "0"}], ")"}], "\[And]", 
                
                RowBox[{"y", "\[LessEqual]", 
                  RowBox[{
                    StyleBox["P",
                      FontWeight->"Bold",
                      FontSlant->"Italic",
                      FontColor->RGBColor[0, 0, 1],
                      Background->None], "*", 
                    SuperscriptBox[
                      StyleBox["Q",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None], \(-1\)]}]}], "\[And]", 
                RowBox[{
                  RowBox[{
                    StyleBox["P",
                      FontWeight->"Bold",
                      FontSlant->"Italic",
                      FontColor->RGBColor[0, 0, 1],
                      Background->None], "*", 
                    SuperscriptBox[
                      StyleBox["Q",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None], \(-1\)]}], "<", \(d + y\)}], 
                "\[And]", \(0 < d\), "\[And]", \(d \[LessEqual] 1\), "\[And]",
                 
                RowBox[{"d", "\[GreaterEqual]", 
                  StyleBox["Tol",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None]}], "\[And]", 
                RowBox[{"(", 
                  RowBox[{"T1", ":=", 
                    RowBox[{"d", "+", 
                      RowBox[{\((\(-1\))\), "*", 
                        StyleBox["Tol",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}]}]}], ")"}]}], "\[Implies]", 
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      StyleBox["P",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None], "<", \(a + b\)}], "\[Implies]", 
                    RowBox[{
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{\(\(-1\)\/2*b\), "+", 
                            RowBox[{\(1\/4\), "*", "d", "*", 
                              StyleBox["Q",
                                FontWeight->"Bold",
                                FontSlant->"Italic",
                                FontColor->RGBColor[0, 0, 1],
                                Background->None]}]}], "=", "0"}], ")"}], 
                      "\[And]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{\(1\/2*a*d\), "+", 
                            
                            RowBox[{\((\(-1\)\/2)\), "*", "d", "*", "y", "*", 
                              
                              StyleBox["Q",
                                FontWeight->"Bold",
                                FontSlant->"Italic",
                                FontColor->RGBColor[0, 0, 1],
                                Background->None]}]}], "=", "0"}], ")"}], 
                      "\[And]", 
                      RowBox[{"y", "\[LessEqual]", 
                        RowBox[{
                          StyleBox["P",
                            FontWeight->"Bold",
                            FontSlant->"Italic",
                            FontColor->RGBColor[0, 0, 1],
                            Background->None], "*", 
                          SuperscriptBox[
                            StyleBox["Q",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None], \(-1\)]}]}], "\[And]", 
                      RowBox[{
                        RowBox[{
                          StyleBox["P",
                            FontWeight->"Bold",
                            FontSlant->"Italic",
                            FontColor->RGBColor[0, 0, 1],
                            Background->None], "*", 
                          SuperscriptBox[
                            StyleBox["Q",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None], \(-1\)]}], 
                        "<", \(1\/2*d + y\)}], "\[And]", \(0 < 1\/2*d\), 
                      "\[And]", \(1\/2*d \[LessEqual] 1\)}]}], ")"}], 
                "\[And]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      StyleBox["P",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None], "\[GreaterEqual]", \(a + b\)}], 
                    "\[Implies]", 
                    RowBox[{
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{\(\(-1\)\/2*b\), "+", 
                            RowBox[{\(1\/4\), "*", "d", "*", 
                              StyleBox["Q",
                                FontWeight->"Bold",
                                FontSlant->"Italic",
                                FontColor->RGBColor[0, 0, 1],
                                Background->None]}]}], "=", "0"}], ")"}], 
                      "\[And]", 
                      RowBox[{"(", 
                        RowBox[{
                          RowBox[{\(1\/2*\((a + b)\)*d\), "+", 
                            
                            RowBox[{\((\(-1\)\/2)\), "*", "d", 
                              "*", \((1\/2*d + y)\), "*", 
                              StyleBox["Q",
                                FontWeight->"Bold",
                                FontSlant->"Italic",
                                FontColor->RGBColor[0, 0, 1],
                                Background->None]}]}], "=", "0"}], ")"}], 
                      "\[And]", 
                      RowBox[{\(1\/2*d + y\), "\[LessEqual]", 
                        RowBox[{
                          StyleBox["P",
                            FontWeight->"Bold",
                            FontSlant->"Italic",
                            FontColor->RGBColor[0, 0, 1],
                            Background->None], "*", 
                          SuperscriptBox[
                            StyleBox["Q",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None], \(-1\)]}]}], "\[And]", 
                      RowBox[{
                        RowBox[{
                          StyleBox["P",
                            FontWeight->"Bold",
                            FontSlant->"Italic",
                            FontColor->RGBColor[0, 0, 1],
                            Background->None], "*", 
                          SuperscriptBox[
                            StyleBox["Q",
                              FontWeight->"Bold",
                              FontSlant->"Italic",
                              FontColor->RGBColor[0, 0, 1],
                              Background->None], \(-1\)]}], "<", \(d + y\)}], 
                      "\[And]", \(0 < 1\/2*d\), 
                      "\[And]", \(1\/2*d \[LessEqual] 1\)}]}], ")"}], 
                "\[And]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      StyleBox["P",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None], "<", \(a + b\)}], "\[Implies]", 
                    RowBox[{
                      RowBox[{\(1\/2*d\), "+", 
                        RowBox[{\((\(-1\))\), "*", 
                          StyleBox["Tol",
                            FontWeight->"Bold",
                            FontSlant->"Italic",
                            FontColor->RGBColor[0, 0, 1],
                            Background->None]}]}], "<", "T1"}]}], ")"}], 
                "\[And]", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{
                      StyleBox["P",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None], "\[GreaterEqual]", \(a + b\)}], 
                    "\[Implies]", 
                    RowBox[{
                      RowBox[{\(1\/2*d\), "+", 
                        RowBox[{\((\(-1\))\), "*", 
                          StyleBox["Tol",
                            FontWeight->"Bold",
                            FontSlant->"Italic",
                            FontColor->RGBColor[0, 0, 1],
                            Background->None]}]}], "<", "T1"}]}], ")"}]}]}]}],
           "\n", 
          RowBox[{\((WHILE . Final)\), "\t", 
            RowBox[{
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{\(\(-1\)*b\), "+", 
                      RowBox[{\(1\/2\), "*", "d", "*", 
                        StyleBox["Q",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}]}], "=", "0"}], ")"}], "\[And]", 
                
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{\(a*d\), "+", 
                      RowBox[{\((\(-1\))\), "*", "d", "*", "y", "*", 
                        StyleBox["Q",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}]}], "=", "0"}], ")"}], "\[And]", 
                
                RowBox[{"y", "\[LessEqual]", 
                  RowBox[{
                    StyleBox["P",
                      FontWeight->"Bold",
                      FontSlant->"Italic",
                      FontColor->RGBColor[0, 0, 1],
                      Background->None], "*", 
                    SuperscriptBox[
                      StyleBox["Q",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None], \(-1\)]}]}], "\[And]", 
                RowBox[{
                  RowBox[{
                    StyleBox["P",
                      FontWeight->"Bold",
                      FontSlant->"Italic",
                      FontColor->RGBColor[0, 0, 1],
                      Background->None], "*", 
                    SuperscriptBox[
                      StyleBox["Q",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None], \(-1\)]}], "<", \(d + y\)}], 
                "\[And]", \(0 < d\), "\[And]", \(d \[LessEqual] 1\), "\[And]",
                 
                RowBox[{"d", "\[NotGreaterEqual]", 
                  StyleBox["Tol",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None]}]}], "\[Implies]", 
              RowBox[{
                RowBox[{
                  RowBox[{
                    StyleBox["P",
                      FontWeight->"Bold",
                      FontSlant->"Italic",
                      FontColor->RGBColor[0, 0, 1],
                      Background->None], "*", 
                    SuperscriptBox[
                      StyleBox["Q",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None], \(-1\)]}], "<", 
                  RowBox[{"y", "+", 
                    StyleBox["Tol",
                      FontWeight->"Bold",
                      FontSlant->"Italic",
                      FontColor->RGBColor[0, 0, 1],
                      Background->None]}]}], "\[And]", 
                RowBox[{"y", "\[LessEqual]", 
                  RowBox[{
                    StyleBox["P",
                      FontWeight->"Bold",
                      FontSlant->"Italic",
                      FontColor->RGBColor[0, 0, 1],
                      Background->None], "*", 
                    SuperscriptBox[
                      StyleBox["Q",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None], \(-1\)]}]}]}]}]}], "\n", 
          RowBox[{\((WHILE . Term)\), "\t", 
            RowBox[{
              RowBox[{
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{\(\(-1\)*b\), "+", 
                      RowBox[{\(1\/2\), "*", "d", "*", 
                        StyleBox["Q",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}]}], "=", "0"}], ")"}], "\[And]", 
                
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{\(a*d\), "+", 
                      RowBox[{\((\(-1\))\), "*", "d", "*", "y", "*", 
                        StyleBox["Q",
                          FontWeight->"Bold",
                          FontSlant->"Italic",
                          FontColor->RGBColor[0, 0, 1],
                          Background->None]}]}], "=", "0"}], ")"}], "\[And]", 
                
                RowBox[{"y", "\[LessEqual]", 
                  RowBox[{
                    StyleBox["P",
                      FontWeight->"Bold",
                      FontSlant->"Italic",
                      FontColor->RGBColor[0, 0, 1],
                      Background->None], "*", 
                    SuperscriptBox[
                      StyleBox["Q",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None], \(-1\)]}]}], "\[And]", 
                RowBox[{
                  RowBox[{
                    StyleBox["P",
                      FontWeight->"Bold",
                      FontSlant->"Italic",
                      FontColor->RGBColor[0, 0, 1],
                      Background->None], "*", 
                    SuperscriptBox[
                      StyleBox["Q",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None], \(-1\)]}], "<", \(d + y\)}], 
                "\[And]", \(0 < d\), "\[And]", \(d \[LessEqual] 1\), "\[And]",
                 
                RowBox[{"d", "\[GreaterEqual]", 
                  StyleBox["Tol",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None]}]}], "\[Implies]", 
              RowBox[{
                RowBox[{"d", "+", 
                  RowBox[{\((\(-1\))\), "*", 
                    StyleBox["Tol",
                      FontWeight->"Bold",
                      FontSlant->"Italic",
                      FontColor->RGBColor[0, 0, 1],
                      Background->None]}]}], "\[GreaterEqual]", "0"}]}]}], 
          "\n", 
          RowBox[{\((Init)\), "\t", 
            RowBox[{
              RowBox[{
                RowBox[{"IsReal", "[", 
                  StyleBox["P",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], "]"}], "\[And]", 
                RowBox[{"IsReal", "[", 
                  StyleBox["Q",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], "]"}], "\[And]", 
                RowBox[{"IsReal", "[", 
                  StyleBox["Tol",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], "]"}], "\[And]", 
                RowBox[{
                  StyleBox["Q",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], ">", 
                  StyleBox["P",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None]}], "\[And]", 
                RowBox[{
                  StyleBox["P",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], "\[GreaterEqual]", "0"}], "\[And]", 
                RowBox[{
                  StyleBox["Tol",
                    FontWeight->"Bold",
                    FontSlant->"Italic",
                    FontColor->RGBColor[0, 0, 1],
                    Background->None], ">", "0"}]}], "\[Implies]", 
              RowBox[{\((0 = 0)\), "\[And]", \((0 = 0)\), "\[And]", 
                RowBox[{"0", "\[LessEqual]", 
                  RowBox[{
                    StyleBox["P",
                      FontWeight->"Bold",
                      FontSlant->"Italic",
                      FontColor->RGBColor[0, 0, 1],
                      Background->None], "*", 
                    SuperscriptBox[
                      StyleBox["Q",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None], \(-1\)]}]}], "\[And]", 
                RowBox[{
                  RowBox[{
                    StyleBox["P",
                      FontWeight->"Bold",
                      FontSlant->"Italic",
                      FontColor->RGBColor[0, 0, 1],
                      Background->None], "*", 
                    SuperscriptBox[
                      StyleBox["Q",
                        FontWeight->"Bold",
                        FontSlant->"Italic",
                        FontColor->RGBColor[0, 0, 1],
                        Background->None], \(-1\)]}], "<", "1"}]}]}]}]}]}], 
      TraditionalForm]], "Output",
  CellLabel->"TS_Out[266]//TraditionalForm="]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Example: Hardware Style Integer Division (Manna)\
\>", "Subsection",
  CellDingbat->None,
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  FontSize->24],

Cell[BoxData[
    \(Specification["\<HardDiv\>", 
      HardDiv[\(\(\[DownArrow]\)\(x1\)\), \(\(\[DownArrow]\)\(x2\)\), \(\(\
\[UpArrow]\)\(z1\)\), \(\(\[UpArrow]\)\(z2\)\)], \[IndentingNewLine]Pre \
\[Rule] \((x1 \[GreaterEqual] 0\  \[And] \ 
            x2 \[GreaterEqual] 
              0)\), \[IndentingNewLine]Post \[Rule] \((0 \[LessEqual] z1 < 
                x2\  \[And] \ x1 = 
            z2*x2 + z1\ )\)\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(Program["\<HardDiv\>", 
      HardDiv[\(\(\[DownArrow]\)\(x1\)\), \(\(\[DownArrow]\)\(x2\)\), \(\(\
\[UpArrow]\)\(z1\)\), \(\(\[UpArrow]\)\(z2\)\)], \
\[IndentingNewLine]Module[{y1, y2, y3, y4, sw}, \[IndentingNewLine]\t
        y1 := x1; \[IndentingNewLine]\ty2 := x2; \[IndentingNewLine]\t
        y3 := 1; \[IndentingNewLine]\ty4 := 0; \[IndentingNewLine]\t
        sw := 1; \[IndentingNewLine]\t
        WHILE[y1 \[LessEqual] y2, \[IndentingNewLine]\t\t\ty2 := 
            2*y2; \[IndentingNewLine]\t\t\ty3 := 
            2*y3, \[IndentingNewLine]\t\t\tTerminationTerm \[Rule] 
            y2 - y1\[IndentingNewLine]\t\ \ \ \ \ ]; \[IndentingNewLine]\ \ \ \
\ \ \ \ \ \ \ WHILE[
          sw = 1, \[IndentingNewLine]\t\t\tIF[
            y1 \[GreaterEqual] y2, \[IndentingNewLine]\t\t\t\t\ty1 := 
              y1 - y2; 
            y4 := y4 + 
                y3\[IndentingNewLine]\t\t\t]; \[IndentingNewLine]\t\t\tIF[
            y3 = 1, \[IndentingNewLine]\t\t\t\t\tsw := 
              0, \[IndentingNewLine]\t\t\t\t\ty2 := y2/2; 
            y3 := y3/2], \[IndentingNewLine]\t\tTerminationTerm \[Rule] 
            sw\[IndentingNewLine]\t]; \[IndentingNewLine]z1 := 
          y1; \[IndentingNewLine]z2 := 
          y4\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell["First WHILE:", "Subsubsection",
  CellMargins->{{69.3125, Inherited}, {Inherited, Inherited}},
  FontSize->18],

Cell[BoxData[
    RowBox[{\((K)\), "  ", 
      RowBox[{
        StyleBox["{",
          SpanMaxSize->Infinity], GridBox[{
            {\(y1\_K = y1\_0\)},
            {\(y2\_K = 2\^K*y2\_0\)},
            {\(y3\_K = 2\^K*y3\_0\)},
            {\(y4\_K = y4\_0\)}
            },
          ColumnAlignments->{Left}], 
        StyleBox["}",
          ShowContents->False]}], " "}]], "Input"],

Cell[TextData[{
  "The obtained invariant formula is -  ",
  StyleBox["using combinatorial and algebraic methods:",
    FontColor->RGBColor[0.501961, 0, 0]]
}], "Text",
  CellMargins->{{55, Inherited}, {Inherited, Inherited}},
  FontWeight->"Bold"],

Cell[BoxData[
    FormBox[
      RowBox[{"\t\t", 
        RowBox[{
          RowBox[{\(\(-1\)*y2\), "+", 
            RowBox[{"y3", "*", 
              StyleBox["x2",
                FontWeight->"Bold",
                FontSlant->"Italic",
                Background->None]}]}], "=", "0"}]}], 
      TraditionalForm]], "Input",
  FormatType->StandardForm]
}, Open  ]],

Cell[CellGroupData[{

Cell["Second WHILE:", "Subsubsection",
  CellMargins->{{68, Inherited}, {Inherited, Inherited}},
  FontSize->18],

Cell[CellGroupData[{

Cell["Program Transformation", "Subsubsection",
  CellDingbat->None,
  CellMargins->{{69.3125, Inherited}, {Inherited, Inherited}},
  FontSize->14,
  FontColor->RGBColor[0.501961, 0, 0]],

Cell["\<\
It has two conditional statements, thus, we obtain 4 subsystems of nested \
loops, as follows:\
\>", "Text",
  CellMargins->{{69.25, Inherited}, {Inherited, Inherited}},
  FontWeight->"Bold"],

Cell[BoxData[{
    \(\((1)\)\), "\[IndentingNewLine]", 
    \(WHILE[
      sw = 1, \[IndentingNewLine]\t\t\tWHILE[
        y1 \[GreaterEqual] y2\  \[And] sw = 
          1, \[IndentingNewLine]\t\t\t\t\ty1 := y1 - y2; 
        y4 := y4 + 
            y3\[IndentingNewLine]\t\t\t]; \[IndentingNewLine]\t\t\tWHILE[
        y3 = \(1\  \[And] \ sw = 1\), \[IndentingNewLine]\t\t\t\t\tsw := 
          0]; \[IndentingNewLine]\t\t\tWHILE[
        y3 \[NotEqual] 1\  \[And] \ sw = 1, \[IndentingNewLine]\t\t\t\t\ty2 := 
          y2/2; y3 := y3/2]]\)}], "Input"],

Cell[BoxData[{
    \(\((2)\)\), "\[IndentingNewLine]", 
    \(WHILE[
      sw = 1, \[IndentingNewLine]\t\t\tWHILE[
        y1 \[GreaterEqual] y2\  \[And] \ sw = 
          1, \[IndentingNewLine]\t\t\t\t\ty1 := y1 - y2; 
        y4 := y4 + 
            y3\[IndentingNewLine]\t\t\t]; \[IndentingNewLine]\t\t\tWHILE[
        y3 \[NotEqual] 1\  \[And] \ sw = 1, \[IndentingNewLine]\t\t\t\t\ty2 := 
          y2/2; y3 := y3/2]; \[IndentingNewLine]\t\t\tWHILE[
        y3 = \(1\  \[And] \ sw = 1\), \[IndentingNewLine]\t\t\t\t\tsw := 
          0]\[IndentingNewLine]\t]\)}], "Input"],

Cell[BoxData[{
    \(\((3)\)\), "\[IndentingNewLine]", 
    \(WHILE[
      sw = 1, \[IndentingNewLine]\t\t\tWHILE[
        y3 = \(1\  \[And] \ sw = 1\), \[IndentingNewLine]\t\t\t\t\tsw := 
          0]; \[IndentingNewLine]\t\t\tWHILE[
        y3 \[NotEqual] 1\  \[And] \ sw = 1, \[IndentingNewLine]\t\t\t\t\ty2 := 
          y2/2; y3 := y3/2]]\)}], "Input"],

Cell[BoxData[{
    \(\((4)\)\), "\[IndentingNewLine]", 
    \(WHILE[
      sw = 1, \[IndentingNewLine]\t\t\tWHILE[
        y3 \[NotEqual] 1\  \[And] \ sw = 1, \[IndentingNewLine]\t\t\t\t\ty2 := 
          y2/2; y3 := y3/2]; \[IndentingNewLine]\t\t\tWHILE[
        y3 = \(1\  \[And] \ sw = 1\), \[IndentingNewLine]\t\t\t\t\tsw := 
          0]]\)}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Obtaining equation system for Nested While subsystems", "Subsubsection",
  CellDingbat->None,
  CellMargins->{{67.9375, Inherited}, {Inherited, Inherited}},
  FontSize->14,
  FontColor->RGBColor[0.501961, 0, 0]],

Cell[BoxData[{
    \(\((1)\)\), "\[IndentingNewLine]", 
    \(WHILE[
      sw = 1, \[IndentingNewLine]\t\t\((L)\)\tWHILE[
          y1 \[GreaterEqual] y2\  \[And] \ sw = 
            1, \[IndentingNewLine]\t\t\t\t\ty1 := y1 - y2; 
          y4 := y4 + 
              y3\[IndentingNewLine]\t\t\ \ \ \t]; \[IndentingNewLine]\t\t\
\((J)\)\tWHILE[
          y3 = \(1\  \[And] \ sw = 1\), \[IndentingNewLine]\t\t\t\t\tsw := 
            0]; \[IndentingNewLine]\t\t\((K)\)\tWHILE[
          y3 \[NotEqual] 1\  \[And] \ sw = 
            1, \[IndentingNewLine]\t\t\t\t\ty2 := y2/2; 
          y3 := y3/2]]\)}], "Input"],

Cell[TextData[{
  "Obtained system of recursive equations (in their closed form - ",
  StyleBox["used combinatorial methods",
    FontColor->RGBColor[0.501961, 0, 0]],
  "):"
}], "Text",
  CellMargins->{{54, Inherited}, {Inherited, Inherited}},
  FontWeight->"Bold"],

Cell[BoxData[
    RowBox[{\((L)\), "  ", 
      RowBox[{
        StyleBox["{",
          SpanMaxSize->Infinity], GridBox[{
            {\(y1\_L = y1\_K - K*y2\_K\)},
            {\(y2\_L = y2\_K\)},
            {\(y3\_L = y3\_K\)},
            {\(y4\_L = y4\_K + L*y3\_K\)}
            },
          ColumnAlignments->{Left}], 
        StyleBox["}",
          ShowContents->False]}], " "}]], "Input"],

Cell[BoxData[
    RowBox[{\((J)\), "  ", 
      RowBox[{
        StyleBox["{",
          SpanMaxSize->Infinity], GridBox[{
            {\(y1\_J = y1\_L\)},
            {\(y2\_J = y2\_L\)},
            {\(y3\_J = y3\_L\)},
            {\(y4\_J = y4\_L\)}
            },
          ColumnAlignments->{Left}], 
        StyleBox["}",
          ShowContents->False]}], " "}]], "Input"],

Cell[BoxData[
    RowBox[{\((S)\), "  ", 
      RowBox[{
        StyleBox["{",
          SpanMaxSize->Infinity], GridBox[{
            {\(y1\_S = y1\_J\)},
            {\(y2\_S = y2\_J/2\^S\)},
            {\(y3\_S = y3\_J/2\^S\)},
            {\(y4\_S = y4\_J\)}
            },
          ColumnAlignments->{Left}], 
        StyleBox["}",
          ShowContents->False]}], " "}]], "Input"],

Cell["\<\
Repeated subsitutions + Combined with initial values (K)-system:\
\>", "Text",
  CellMargins->{{55, Inherited}, {Inherited, Inherited}},
  FontWeight->"Bold"],

Cell[BoxData[
    RowBox[{\((K, \ L, J, S)\), "  ", 
      RowBox[{
        StyleBox["{",
          SpanMaxSize->Infinity], GridBox[{
            {\(y1\_S = y1\_0 - K*\((2\^K*y2\_0)\)\)},
            {\(y2\_S = \((2\^K*y2\_0)\)/2\^S\)},
            {\(y3\_S = \((2\^K*y3\_0)\)/2\^S\)},
            {\(y4\_S = y4\_0 + L*\((2\^K*y3\_0)\)\)}
            },
          ColumnAlignments->{Left}], 
        StyleBox["}",
          ShowContents->False]}], " "}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Solving equation systems, generating invariant formula", "Subsubsection",
  CellDingbat->None,
  CellMargins->{{67.3125, Inherited}, {Inherited, Inherited}},
  FontSize->14,
  FontColor->RGBColor[0.501961, 0, 0]],

Cell[BoxData[
    RowBox[{
      RowBox[{\((1)\), "\n", 
        RowBox[{\((K, \ L, J, S)\), "  ", 
          RowBox[{
            StyleBox["{",
              SpanMaxSize->Infinity], GridBox[{
                {\(y1\_S = y1\_0 - K*\((2\^K*y2\_0)\)\)},
                {\(y2\_S = \((2\^K*y2\_0)\)/2\^S\)},
                {\(y3\_S = \((2\^K*y3\_0)\)/2\^S\)},
                {\(y4\_S = y4\_0 + L*\((2\^K*y3\_0)\)\)}
                },
              ColumnAlignments->{Left}], 
            StyleBox["}",
              ShowContents->False]}]}]}], " "}]], "Input"],

Cell[TextData[{
  StyleBox["Eliminating {K,L,J,S}",
    FontWeight->"Bold",
    FontColor->RGBColor[1, 0, 0]],
  " and initial value substituion yields :"
}], "Text",
  CellMargins->{{55, Inherited}, {Inherited, Inherited}}],

Cell[BoxData[
    \({x1 + \((\(-1\))\) y1 + \((\(-1\))\) x2  y4 \[Equal] 
        0, \[IndentingNewLine]y2 + \((\(-1\))\) x2  y3 \[Equal] 
        0, \[IndentingNewLine]x1\ y3 + \((\(-1\))\) y1  y3 + \((\(-1\))\) y2  
            y4 \[Equal] 0, \[IndentingNewLine]\(-y2\) + x2\ y3 \[Equal] 
        0}\)], "Input"],

Cell[TextData[{
  "After ",
  StyleBox["Invariance Checking",
    FontWeight->"Bold",
    FontColor->RGBColor[1, 0, 0]],
  ", remaining formulae:"
}], "Text",
  CellMargins->{{55, Inherited}, {Inherited, Inherited}}],

Cell[BoxData[
    \({y2 - x2*y3 \[Equal] 0, \ \ \ x1*y3 - y1*y3 - y2*y4 \[Equal] 
        0, \ \ \ \ y2 - x2*\ y3 \[Equal] 0}\)], "Input"],

Cell[TextData[{
  "After using ",
  StyleBox["Groebner basis",
    FontWeight->"Bold",
    FontColor->RGBColor[1, 0, 0]],
  ", remaining formulae"
}], "Text",
  CellMargins->{{55, Inherited}, {Inherited, Inherited}}],

Cell[BoxData[
    \({x1\ y3 + \((\(-1\))\) y1  y3 + \((\(-1\))\) x2y3y4\  = \ 0, 
      y2 + \((\(-1\))\) x2y3\  = \ 0}\)], "Input"],

Cell[TextData[{
  "Thus the ",
  StyleBox["Invariant",
    FontWeight->"Bold",
    FontColor->RGBColor[1, 0, 0]],
  StyleBox[" ",
    FontWeight->"Bold"],
  "is:"
}], "Text",
  CellMargins->{{55, Inherited}, {Inherited, Inherited}}],

Cell[BoxData[
    RowBox[{
      StyleBox["\t",
        FontColor->GrayLevel[
        0]], \(y2 \[Equal] x2\ y3\ \ \ \ \  \[And] \ \ \ \ x1\ y3 \[Equal] 
          y3\ \((y1 + x2\ y4)\)\)}]], "Input"]
}, Open  ]],

Cell["\<\
\[Implies]   using NESTED SUMS - C.Schneider\
\>", "Subsubsection",
  CellDingbat->None,
  CellMargins->{{53, Inherited}, {Inherited, Inherited}},
  FontSize->12]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example: Binary Power", "Subsection",
  CellDingbat->None,
  CellMargins->{{36, Inherited}, {Inherited, Inherited}},
  FontSize->24],

Cell[BoxData[
    \(Specification["\<BinPow\>", 
      BinPow[\(\(\[DownArrow]\)\(x1\)\), \(\(\[DownArrow]\)\(x2\)\), \(\(\
\[UpArrow]\)\(z\)\)], \[IndentingNewLine]Pre \[Rule] \((x1 > 0\  \[And] \ 
            x2 \[GreaterEqual] 0\  \[And] \ IsInteger[x1]\  \[And] \ 
            IsInteger[x2])\), \[IndentingNewLine]Post \[Rule] \((z = 
            x1\^x2\ )\)\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(Program["\<BinPow\>", 
      BinPow[\(\(\[DownArrow]\)\(x1\)\), \(\(\[DownArrow]\)\(x2\)\), \(\(\
\[UpArrow]\)\(z\)\)], \[IndentingNewLine]Module[{y1, y2, 
          y3}, \[IndentingNewLine]\ty1 := x1; \[IndentingNewLine]\t
        y2 := x2; \[IndentingNewLine]\ty3 := 1; \[IndentingNewLine]\t
        WHILE[y2 \[NotEqual] 0, \[IndentingNewLine]\t\tIF[
            Mod[y2, 2] \[Equal] \ 1, \[IndentingNewLine]\t\t\ty2 := y2 - 1; 
            y3 := y3*y1, \[IndentingNewLine]\t\t\ty1 := y1*y1, 
            y2 := y2/2], \[IndentingNewLine]\t\tTerminationTerm \[Rule] 
            y2\[IndentingNewLine]\t]; \[IndentingNewLine]\t
        z := y3\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input"],

Cell["Generated Invariant: ", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Log[y3]\/Log[x1] \[Equal] x2 - \(y2\ Log[y1]\)\/Log[x1]\)], "Input"],

Cell[BoxData[
    \(\(\(\[DoubleLeftRightArrow]\)\(\ \ \ \)\(y3*y1\^y2\)\) = 
      x1\^x2\)], "Input"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell["\<\
\[Rule] method for Invariant Generation for Nested Loops\
\>", "Subsubsection",
  CellDingbat->None,
  FontSize->18],

Cell[TextData[Cell[BoxData[GridBox[{
        {
          ButtonBox[
            StyleBox["\[FirstPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageFirst"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"First Slide"], 
          ButtonBox[
            StyleBox["\[LeftPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPagePrevious"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Previous Slide"], 
          ButtonBox[
            StyleBox["\[RightPointer]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageNext"]}],
            ButtonStyle->"SlideHyperlink",
            ButtonNote->"Next Slide"], 
          ButtonBox[
            StyleBox["\[LastPage]",
              "SR"],
            ButtonFunction:>FrontEndExecute[ {
                FrontEndToken[ 
                  FrontEnd`SelectedNotebook[ ], "ScrollPageLast"]}],
            ButtonStyle->"SlideHyperlink"], " ", 
          ButtonBox[
            StyleBox[
              RowBox[{
                CounterBox["SlideShowNavigationBar"], \(\(\ \)\(of\)\(\ \)\), 
                
                
                CounterBox["SlideShowNavigationBar", {None, 
                  "SlideShowHeader", -1}]}],
              "SR"],
            ButtonFrame->"None"]}
        }]]]], "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Conclusion and Future Work",
  FontFamily->"Times New Roman"]], "Section",
  CellDingbat->"\[DiamondSuit]",
  CellMargins->{{18.0625, Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->0,
  FontFamily->"Bookman Old Style",
  FontColor->RGBColor[0.137255, 0.435294, 0.0745098]],

Cell[CellGroupData[{

Cell[TextData[{
  "Invariant Generation ",
  StyleBox["by algebraic and combinatorial methods",
    FontColor->RGBColor[0.501961, 0, 0]],
  "\n",
  StyleBox["(summation, recurrence solving, variable elimination, polynomial \
algebra)",
    FontSize->12]
}], "Text",
  CellDingbat->"\[FivePointedStar]",
  FontSize->16],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Loops only with assignments:",
  FontWeight->"Bold",
  FontColor->RGBColor[0.500008, 0, 0]]], "Text",
  CellMargins->{{54, Inherited}, {Inherited, Inherited}},
  FontSize->14],

Cell["\<\
- efficient method for invariant generation 
(Gosper, geometric series, Generating Function)\
\>", "Text",
  CellMargins->{{84.625, Inherited}, {Inherited, Inherited}}],

Cell[TextData[{
  StyleBox["- future work (F 1305): ",
    FontColor->RGBColor[0.501961, 0, 0]],
  "- integrate new recurrence solving techniques \n\t\t\t\t\[Rule]  Nested \
Sums\n\t\t\t\t\[Rule]  solving system of recurrences\t          \t        "
}], "Text",
  CellMargins->{{84, Inherited}, {Inherited, Inherited}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["Loops with conditionals",
    FontWeight->"Bold",
    FontColor->RGBColor[0.500008, 0, 0]],
  ":  "
}], "Text",
  CellMargins->{{54, Inherited}, {Inherited, Inherited}},
  FontSize->14],

Cell["\<\
- novel-algorithm based on algorithms from combinatorics and polynomial \
algebra \
\>", "Text",
  CellMargins->{{80, Inherited}, {Inherited, Inherited}}],

Cell[TextData[{
  "- the method is also efficient for non-algebraic invariant generation:\n\t\
- using recurrence solving (",
  StyleBox["F 1305",
    FontColor->RGBColor[0.501961, 0, 0]],
  ")\n\t- variable elimination  - ",
  StyleBox["algebraic methods ",
    FontColor->RGBColor[0.501961, 0, 0]],
  "\n\t",
  StyleBox["- future work: ",
    FontColor->RGBColor[0.501961, 0, 0]],
  "  - reduction of obtained invariant properties\n\t\t\t- with sligth \
modifications \[Rule] invariant generation for nested loops\n\t"
}], "Text",
  CellMargins->{{80, Inherited}, {Inherited, Inherited}}]
}, Open  ]]
}, Open  ]],

Cell[TextData[{
  "Generate invariant linear inequalities",
  StyleBox["  ",
    FontSize->14],
  StyleBox["(",
    FontSize->12,
    FontWeight->"Bold"],
  StyleBox["F 1305)",
    FontSize->12,
    FontWeight->"Bold",
    FontColor->RGBColor[0.501961, 0, 0]]
}], "Text",
  CellDingbat->"\[FivePointedStar]",
  FontSize->16],

Cell["\<\
Continue previuos work on automated generation of termination terms \
\>", "Text",
  CellDingbat->"\[FivePointedStar]",
  FontSize->16]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
ScreenStyleEnvironment->"SlideShow",
PrintingStyleEnvironment->"SlideShow",
WindowToolbars->{"RulerBar", "EditBar"},
CellGrouping->Manual,
WindowSize->{1016, 410},
WindowMargins->{{12, Automatic}, {42, Automatic}},
ShowCellLabel->False,
Magnification->1.5,
StyleDefinitions -> Notebook[{
  
  Cell[CellGroupData[{
  Cell["Style Definitions", "Subtitle"],
  
  Cell["\<\
Modify the definitions below to change the default appearance of all cells in \
a given style. Make modifications to any definition using commands in the \
Format menu.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell["Style Environment Names", "Section"],
  
  Cell[StyleData[All, "Working"],
    ScriptMinSize->9],
  
  Cell[StyleData[All, "Presentation"],
    CellFrameMargins->8,
    ScriptMinSize->9],
  
  Cell[StyleData[All, "SlideShow"],
    PageWidth->WindowWidth,
    ScrollingOptions->{"PagewiseDisplay"->True,
    "VerticalScrollRange"->Fit},
    ScriptMinSize->9],
  
  Cell[StyleData[All, "Printout"],
    PageWidth->PaperWidth,
    ShowCellLabel->False,
    ImageSize->{200, 200},
    PrivateFontOptions->{"FontType"->"Outline"}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Notebook Options", "Section"],
  
  Cell["\<\
The options defined for the style below will be used at the Notebook level.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Notebook"],
    PageHeaders->{{Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"], None, Cell[ 
            TextData[ {
              ValueBox[ "FileName"]}], "Header"]}, {Cell[ 
            TextData[ {
              ValueBox[ "FileName"]}], "Header"], None, Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"]}},
    PageHeaderLines->{True, True},
    PrintingOptions->{"FirstPageHeader"->False,
    "FacingPages"->True},
    CellLabelAutoDelete->False,
    CellFrameLabelMargins->6,
    StyleMenuListing->None],
  
  Cell[StyleData["Notebook", "Presentation"],
    FontSize->12]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Headings", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Title"],
    CellFrame->{{0, 0}, {0, 0.25}},
    CellMargins->{{18, 30}, {0, 3}},
    CellGroupingRules->{"TitleGrouping", 0},
    PageBreakBelow->False,
    CellFrameMargins->9,
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], Inherited},
    LineSpacing->{0.95, 11},
    CounterIncrements->"Title",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}},
    FontSize->36,
    FontColor->GrayLevel[1],
    Background->RGBColor[0.160784, 0.505882, 0.0862745]],
  
  Cell[StyleData["Title", "Presentation"],
    CellMargins->{{25, 30}, {0, 3}},
    CellFrameMargins->{{6, 10}, {10, 14}}],
  
  Cell[StyleData["Title", "Printout"],
    CellMargins->{{18, 30}, {0, 3}},
    CellFrameMargins->4]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subtitle"],
    CellMargins->{{18, 30}, {0, 4}},
    CellGroupingRules->{"TitleGrouping", 10},
    PageBreakBelow->False,
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], Inherited},
    LineSpacing->{1, 0},
    CounterIncrements->"Subtitle",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}},
    FontSize->14,
    FontSlant->"Italic"],
  
  Cell[StyleData["Subtitle", "Presentation"],
    CellMargins->{{25, 40}, {55, 4}}],
  
  Cell[StyleData["Subtitle", "Printout"],
    CellMargins->{{18, 30}, {0, 4}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SectionFirst"],
    CellFrame->{{0, 0}, {0, 3}},
    CellMargins->{{18, 30}, {4, 30}},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    CellFrameMargins->3,
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], Inherited},
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    FontSize->18,
    FontWeight->"Bold"],
  
  Cell[StyleData["SectionFirst", "Presentation"],
    CellFrame->{{0, 0}, {0, 8}},
    CellMargins->{{25, 30}, {65, 10}},
    FontSize->27],
  
  Cell[StyleData["SectionFirst", "Printout"],
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Section"],
    CellDingbat->"\[DiamondSuit]",
    CellMargins->{{18, 30}, {4, 5}},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], Inherited},
    DelimiterFlashTime->0.1,
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    FontSize->28,
    FontWeight->"Bold",
    FontColor->RGBColor[0.160784, 0.505882, 0.0862745]],
  
  Cell[StyleData["Section", "Presentation"],
    CellMargins->{{25, 30}, {30, 5}},
    DelimiterFlashTime->0.1],
  
  Cell[StyleData["Section", "Printout"],
    CellMargins->{{Inherited, Inherited}, {Inherited, 5}},
    DelimiterFlashTime->0.1]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsection"],
    CellDingbat->None,
    CellMargins->{{18, 30}, {4, 20}},
    CellGroupingRules->{"SectionGrouping", 50},
    PageBreakBelow->False,
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], Inherited},
    CounterIncrements->"Subsection",
    CounterAssignments->{{"Subsubsection", 0}},
    FontSize->25,
    FontWeight->"Bold",
    FontColor->RGBColor[0.501961, 0, 0]],
  
  Cell[StyleData["Subsection", "Presentation"],
    CellDingbat->None,
    CellMargins->{{25, 30}, {30, 20}}],
  
  Cell[StyleData["Subsection", "Printout"],
    CellDingbat->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubsection"],
    CellDingbat->"\[EmptyDownTriangle]",
    CellMargins->{{18, 30}, {4, 12}},
    CellGroupingRules->{"SectionGrouping", 60},
    PageBreakBelow->False,
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], Inherited},
    CounterIncrements->"Subsubsection",
    FontSize->22,
    FontWeight->"Bold",
    FontColor->RGBColor[0.137255, 0.435294, 0.0745098]],
  
  Cell[StyleData["Subsubsection", "Presentation"],
    CellDingbat->"\[EmptyDownTriangle]",
    CellMargins->{{25, 30}, {10, 10}}],
  
  Cell[StyleData["Subsubsection", "Printout"],
    CellDingbat->"\[EmptyDownTriangle]"]
  }, Open  ]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Body Text", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Text"],
    CellMargins->{{18, 10}, {Inherited, 6}},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], Inherited},
    TextJustification->1,
    LineSpacing->{1, 2},
    CounterIncrements->"Text"],
  
  Cell[StyleData["Text", "Presentation"],
    CellMargins->{{25, 10}, {6, 20}},
    FontSize->18],
  
  Cell[StyleData["Text", "Printout"],
    CellMargins->{{18, 30}, {Inherited, 4}},
    Hyphenation->True,
    LineSpacing->{1, 3},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Caption"],
    CellMargins->{{55, 50}, {5, 5}},
    PageBreakAbove->False,
    FontSize->10],
  
  Cell[StyleData["Caption", "Presentation"],
    CellMargins->{{80, 50}, {8, 14}},
    FontSize->15],
  
  Cell[StyleData["Caption", "Printout"],
    CellMargins->{{55, 55}, {5, 2}},
    Hyphenation->True,
    FontSize->8]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Input/Output", "Section"],
  
  Cell["\<\
The cells in this section define styles used for input and output to the \
kernel.  Be careful when modifying, renaming, or removing these styles, \
because the front end associates special meanings with these style names.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Input"],
    CellFrame->0.5,
    CellMargins->{{55, 10}, {5, 8}},
    CellBracketOptions->{"Color"->RGBColor[0, 0, 1]},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelMargins->{{26, Inherited}, {Inherited, Inherited}},
    CellFrameColor->RGBColor[0, 0, 1],
    DefaultFormatType->DefaultInputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->"Formula",
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    LinebreakAdjustments->{0.85, 2, 10, 0, 1},
    CounterIncrements->"Input",
    FontSize->12,
    FontWeight->"Bold",
    Background->GrayLevel[1]],
  
  Cell[StyleData["Input", "Presentation"],
    CellFrame->0.5,
    CellMargins->{{80, 10}, {8, 15}},
    CellBracketOptions->{"Color"->RGBColor[0, 0, 1]},
    CellFrameColor->RGBColor[0, 0, 1],
    FontSize->18],
  
  Cell[StyleData["Input", "Printout"],
    CellFrame->0.5,
    CellMargins->{{55, 55}, {0, 10}},
    CellBracketOptions->{"Color"->RGBColor[0, 0, 1]},
    ShowCellLabel->False,
    CellFrameColor->RGBColor[0, 0, 1],
    LinebreakAdjustments->{0.85, 2, 10, 1, 1},
    FontSize->9.5]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Output"],
    CellMargins->{{55, 10}, {8, 5}},
    CellEditDuplicate->True,
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    CellLabelPositioning->Left,
    CellLabelMargins->{{26, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultOutputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->"Formula",
    FormatType->InputForm,
    CounterIncrements->"Output"],
  
  Cell[StyleData["Output", "Presentation"],
    CellMargins->{{80, 10}, {30, 12}},
    FontSize->16],
  
  Cell[StyleData["Output", "Printout"],
    CellMargins->{{55, 55}, {10, 10}},
    ShowCellLabel->False,
    FontSize->9.5]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Message"],
    CellDingbat->"\[LongDash]",
    CellMargins->{{55, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"OutputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    CellLabelMargins->{{26, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultOutputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    AutoStyleOptions->{"UnmatchedBracketStyle"->None},
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    FormatType->InputForm,
    CounterIncrements->"Message",
    StyleMenuListing->None,
    FontSize->10,
    FontSlant->"Italic"],
  
  Cell[StyleData["Message", "Presentation"],
    CellMargins->{{80, 10}, {15, 8}},
    FontSize->15],
  
  Cell[StyleData["Message", "Printout"],
    CellMargins->{{55, 55}, {0, 3}},
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Print"],
    CellMargins->{{55, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    CellLabelMargins->{{26, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultOutputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    TextAlignment->Left,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    FormatType->InputForm,
    CounterIncrements->"Print",
    StyleMenuListing->None],
  
  Cell[StyleData["Print", "Presentation"],
    CellMargins->{{80, 10}, {12, 8}},
    FontSize->16],
  
  Cell[StyleData["Print", "Printout"],
    CellMargins->{{54, 72}, {2, 10}},
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Graphics"],
    CellMargins->{{55, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->DefaultOutputFormatType,
    FormatType->InputForm,
    CounterIncrements->"Graphics",
    StyleMenuListing->None],
  
  Cell[StyleData["Graphics", "Presentation"],
    CellMargins->{{80, 10}, {10, 10}},
    FontSize->16],
  
  Cell[StyleData["Graphics", "Printout"],
    CellMargins->{{55, 55}, {0, 15}},
    ImageSize->{0.0625, 0.0625},
    ImageMargins->{{35, Inherited}, {Inherited, 0}},
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CellLabel"],
    CellMargins->{{9, Inherited}, {Inherited, Inherited}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontSlant->"Oblique"],
  
  Cell[StyleData["CellLabel", "Presentation"],
    FontSize->14],
  
  Cell[StyleData["CellLabel", "Printout"],
    CellMargins->{{0, Inherited}, {Inherited, Inherited}},
    FontSize->8]
  }, Closed]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell["Unique Styles", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Author"],
    CellMargins->{{45, Inherited}, {2, 20}},
    CellGroupingRules->{"TitleGrouping", 20},
    PageBreakBelow->False,
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}},
    FontSize->14,
    FontWeight->"Bold"],
  
  Cell[StyleData["Author", "Presentation"],
    CellMargins->{{65, 30}, {4, 30}},
    FontSize->21],
  
  Cell[StyleData["Author", "Printout"],
    CellMargins->{{36, Inherited}, {2, 30}},
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Address"],
    CellMargins->{{45, Inherited}, {2, 2}},
    CellGroupingRules->{"TitleGrouping", 30},
    PageBreakBelow->False,
    LineSpacing->{1, 1},
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}},
    FontSize->12,
    FontSlant->"Italic"],
  
  Cell[StyleData["Address", "Presentation"],
    CellMargins->{{65, 30}, {40, 2}},
    FontSize->18],
  
  Cell[StyleData["Address", "Printout"],
    CellMargins->{{36, Inherited}, {2, 2}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Abstract"],
    CellMargins->{{45, 75}, {Inherited, 30}},
    LineSpacing->{1, 0}],
  
  Cell[StyleData["Abstract", "Presentation"],
    CellMargins->{{65, 30}, {8, 25}},
    FontSize->18],
  
  Cell[StyleData["Abstract", "Printout"],
    CellMargins->{{36, 67}, {Inherited, 50}},
    Hyphenation->True,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Reference"],
    CellMargins->{{18, 40}, {2, 2}},
    TextJustification->1,
    LineSpacing->{1, 0}],
  
  Cell[StyleData["Reference", "Presentation"],
    CellMargins->{{25, 40}, {2, 2}},
    FontSize->18],
  
  Cell[StyleData["Reference", "Printout"],
    CellMargins->{{18, 40}, {Inherited, 0}},
    Hyphenation->True,
    FontSize->8]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Hyperlink Styles", "Section"],
  
  Cell["\<\
The cells below define styles useful for making hypertext ButtonBoxes.  The \
\"Hyperlink\" style is for links within the same Notebook, or between \
Notebooks.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Hyperlink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonNote->ButtonData}],
  
  Cell[StyleData["Hyperlink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell["\<\
The following styles are for linking automatically to the on-line help \
system.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MainBookLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "MainBook", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["MainBookLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AddOnsLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "AddOns", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["AddOnsLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RefGuideLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "RefGuide", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["RefGuideLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["GettingStartedLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "GettingStarted", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["GettingStartedLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DemosLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "Demos", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["DemosLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["DemosLink", "EnhancedPrintout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["DemosLink", "EnhancedPrintoutNonGray"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TourLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "Tour", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["TourLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["TourLink", "EnhancedPrintout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["TourLink", "EnhancedPrintoutNonGray"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["OtherInformationLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "OtherInformation", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["OtherInformationLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MasterIndexLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "MasterIndex", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["MasterIndexLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["MasterIndexLink", "EnhancedPrintout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["MasterIndexLink", "EnhancedPrintoutNonGray"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Palette Styles", "Section"],
  
  Cell["\<\
The cells below define styles that define standard ButtonFunctions, for use \
in palette buttons.\
\>", "Text"],
  
  Cell[StyleData["Paste"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, After]}]&)}],
  
  Cell[StyleData["Evaluate"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        SelectionEvaluate[ 
          FrontEnd`InputNotebook[ ], All]}]&)}],
  
  Cell[StyleData["EvaluateCell"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionMove[ 
          FrontEnd`InputNotebook[ ], All, Cell, 1], 
        FrontEnd`SelectionEvaluateCreateCell[ 
          FrontEnd`InputNotebook[ ], All]}]&)}],
  
  Cell[StyleData["CopyEvaluate"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`SelectionCreateCell[ 
          FrontEnd`InputNotebook[ ], All], 
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionEvaluate[ 
          FrontEnd`InputNotebook[ ], All]}]&)}],
  
  Cell[StyleData["CopyEvaluateCell"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`SelectionCreateCell[ 
          FrontEnd`InputNotebook[ ], All], 
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionEvaluateCreateCell[ 
          FrontEnd`InputNotebook[ ], All]}]&)}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Slide Show Styles", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideShowNavigationBar"],
    Editable->False,
    CellFrame->True,
    CellMargins->{{0, 0}, {3, 3}},
    CellElementSpacings->{"CellMinHeight"->0.8125},
    CellGroupingRules->{"SectionGrouping", 30},
    CellFrameMargins->False,
    CellFrameColor->GrayLevel[1],
    CellFrameLabelMargins->False,
    TextAlignment->Center,
    CounterIncrements->"SlideShowNavigationBar",
    StyleMenuListing->None,
    FontSize->10,
    Background->GrayLevel[0.8],
    Magnification->1,
    GridBoxOptions->{GridBaseline->Center,
    RowSpacings->0,
    ColumnSpacings->0,
    ColumnWidths->{3.5, 3.5, 3.5, 3.5, 13, 5, 4},
    RowAlignments->Baseline,
    ColumnAlignments->{
      Center, Center, Center, Center, Center, Center, Right, Center}}],
  
  Cell[StyleData["SlideShowNavigationBar", "Presentation"]],
  
  Cell[StyleData["SlideShowNavigationBar", "SlideShow"],
    Deletable->False,
    ShowCellBracket->False,
    CellMargins->{{-1, -1}, {-1, -1}},
    PageBreakAbove->True,
    CellFrameMargins->{{1, 1}, {0, 0}}],
  
  Cell[StyleData["SlideShowNavigationBar", "Printout"],
    CellMargins->{{18, 4}, {4, 4}},
    LineSpacing->{1, 3},
    FontSize->10]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideShowSection"],
    CellFrame->{{0, 0}, {0, 0.5}},
    CellMargins->{{0, 0}, {10, 0}},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    CellFrameMargins->{{12, 4}, {6, 12}},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], Inherited},
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->18,
    FontWeight->"Plain",
    FontColor->GrayLevel[1],
    Background->RGBColor[0.408011, 0.440726, 0.8]],
  
  Cell[StyleData["SlideShowSection", "Presentation"],
    CellFrameMargins->{{18, 10}, {10, 18}},
    FontSize->27],
  
  Cell[StyleData["SlideShowSection", "SlideShow"],
    ShowCellBracket->False,
    PageBreakAbove->True],
  
  Cell[StyleData["SlideShowSection", "Printout"],
    CellMargins->{{18, 30}, {0, 30}},
    CellFrameMargins->5,
    FontSize->14]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideHyperlink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontSize->26,
    FontColor->GrayLevel[0.400015],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonMinHeight->0.85,
    ButtonMargins->0.5,
    ButtonNote->None}],
  
  Cell[StyleData["SlideHyperlink", "Presentation"],
    CellMargins->{{10, 10}, {10, 12}},
    FontSize->36],
  
  Cell[StyleData["SlideHyperlink", "SlideShow"],
    FontSize->26],
  
  Cell[StyleData["SlideHyperlink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideTOCLink"],
    CellMargins->{{24, Inherited}, {Inherited, Inherited}},
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Helvetica",
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonMargins->1.5,
    ButtonNote->ButtonData}],
  
  Cell[StyleData["SlideTOCLink", "Presentation"],
    CellMargins->{{35, 10}, {15, 12}},
    FontSize->18],
  
  Cell[StyleData["SlideTOCLink", "SlideShow"],
    FontSize->12],
  
  Cell[StyleData["SlideTOCLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideTOC"],
    CellDingbat->"\[Bullet]",
    CellMargins->{{18, Inherited}, {Inherited, Inherited}},
    StyleMenuListing->None,
    FontFamily->"Helvetica"],
  
  Cell[StyleData["SlideTOC", "Presentation"],
    CellMargins->{{25, 10}, {10, 10}},
    FontSize->18],
  
  Cell[StyleData["SlideTOC", "SlideShow"],
    FontSize->14],
  
  Cell[StyleData["SlideTOC", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0]]
  }, Closed]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Automatic Numbering", "Section"],
  
  Cell["\<\
The following styles are useful for numbered equations, figures, etc.  They \
automatically give the cell a FrameLabel containing a reference to a \
particular counter, and also increment that counter.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedEquation"],
    CellMargins->{{55, 10}, {0, 10}},
    CellFrameLabels->{{None, Cell[ 
            TextData[ {"(", 
              CounterBox[ "NumberedEquation"], ")"}]]}, {None, None}},
    DefaultFormatType->DefaultInputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    CounterIncrements->"NumberedEquation",
    FormatTypeAutoConvert->False],
  
  Cell[StyleData["NumberedEquation", "Presentation"],
    CellMargins->{{80, 10}, {0, 20}},
    FontSize->18],
  
  Cell[StyleData["NumberedEquation", "Printout"],
    CellMargins->{{55, 55}, {0, 10}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedFigure"],
    CellMargins->{{55, 145}, {2, 10}},
    CellHorizontalScrolling->True,
    CellFrameLabels->{{None, None}, {Cell[ 
            TextData[ {"Figure ", 
              CounterBox[ "NumberedFigure"]}], FontWeight -> "Bold"], None}},
    CounterIncrements->"NumberedFigure",
    FormatTypeAutoConvert->False],
  
  Cell[StyleData["NumberedFigure", "Presentation"],
    CellMargins->{{80, 10}, {0, 20}},
    FontSize->18],
  
  Cell[StyleData["NumberedFigure", "Printout"],
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedTable"],
    CellMargins->{{55, 145}, {2, 10}},
    CellFrameLabels->{{None, None}, {Cell[ 
            TextData[ {"Table ", 
              CounterBox[ "NumberedTable"]}], FontWeight -> "Bold"], None}},
    TextAlignment->Center,
    CounterIncrements->"NumberedTable",
    FormatTypeAutoConvert->False],
  
  Cell[StyleData["NumberedTable", "Presentation"],
    CellMargins->{{80, 10}, {0, 20}},
    FontSize->18],
  
  Cell[StyleData["NumberedTable", "Printout"],
    CellMargins->{{18, Inherited}, {Inherited, Inherited}},
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Formulas and Programming", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DisplayFormula"],
    CellMargins->{{55, 10}, {2, 10}},
    CellHorizontalScrolling->True,
    DefaultFormatType->DefaultInputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->"Formula",
    ScriptLevel->0,
    SingleLetterItalics->True,
    UnderoverscriptBoxOptions->{LimitsPositioning->True}],
  
  Cell[StyleData["DisplayFormula", "Presentation"],
    CellMargins->{{80, 10}, {5, 25}},
    FontSize->18],
  
  Cell[StyleData["DisplayFormula", "Printout"],
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ChemicalFormula"],
    CellMargins->{{55, 10}, {2, 10}},
    DefaultFormatType->DefaultInputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->"Formula",
    AutoSpacing->False,
    ScriptLevel->1,
    ScriptBaselineShifts->{0.6, Automatic},
    SingleLetterItalics->False,
    ZeroWidthTimes->True],
  
  Cell[StyleData["ChemicalFormula", "Presentation"],
    CellMargins->{{80, 10}, {5, 15}},
    FontSize->18],
  
  Cell[StyleData["ChemicalFormula", "Printout"],
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Program"],
    CellMargins->{{18, 10}, {Inherited, 6}},
    Hyphenation->False,
    LanguageCategory->"Formula",
    FontFamily->"Courier"],
  
  Cell[StyleData["Program", "Presentation"],
    CellMargins->{{25, 10}, {8, 20}},
    FontSize->16],
  
  Cell[StyleData["Program", "Printout"],
    CellMargins->{{18, 30}, {Inherited, 4}},
    FontSize->9.5]
  }, Closed]]
  }, Closed]]
  }, Open  ]]
  }]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "SlideShowHeader"->{
    Cell[1754, 51, 1717, 45, 20, "SlideShowNavigationBar",
      CellTags->"SlideShowHeader"],
    Cell[5473, 161, 1717, 45, 20, "SlideShowNavigationBar",
      CellTags->"SlideShowHeader"],
    Cell[11818, 385, 1679, 44, 20, "SlideShowNavigationBar",
      CellTags->"SlideShowHeader"],
    Cell[19675, 653, 1679, 44, 20, "SlideShowNavigationBar",
      CellTags->"SlideShowHeader"],
    Cell[22412, 735, 1679, 44, 20, "SlideShowNavigationBar",
      CellTags->"SlideShowHeader"],
    Cell[82795, 2346, 1679, 44, 20, "SlideShowNavigationBar",
      CellTags->"SlideShowHeader"],
    Cell[129993, 3593, 1679, 44, 20, "SlideShowNavigationBar",
      CellTags->"SlideShowHeader"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"SlideShowHeader", 175684, 5037}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 1717, 45, 20, "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{
Cell[3496, 100, 500, 14, 241, "Title"],
Cell[3999, 116, 390, 11, 122, "Text"],
Cell[4392, 129, 245, 5, 61, "Section"],
Cell[4640, 136, 303, 7, 61, "Section"],
Cell[4946, 145, 237, 5, 61, "Section"],
Cell[5186, 152, 284, 7, 61, "Section"],
Cell[5473, 161, 1717, 45, 20, "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7227, 211, 276, 10, 59, "Section"],

Cell[CellGroupData[{
Cell[7528, 225, 290, 11, 66, "Subsection"],
Cell[7821, 238, 1068, 37, 202, "Text"],
Cell[8892, 277, 571, 19, 119, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9500, 301, 145, 3, 45, "Text"],
Cell[9648, 306, 502, 15, 43, "Text"],
Cell[10153, 323, 325, 9, 66, "Text"],
Cell[10481, 334, 204, 6, 42, "Text"],
Cell[10688, 342, 204, 5, 42, "Text"],
Cell[10895, 349, 329, 11, 66, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11261, 365, 126, 2, 64, "Subsection"],
Cell[11390, 369, 197, 5, 42, "Text"],
Cell[11590, 376, 201, 5, 42, "Text"]
}, Open  ]]
}, Open  ]],
Cell[11818, 385, 1679, 44, 20, "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{
Cell[13522, 433, 308, 11, 58, "Section"],

Cell[CellGroupData[{
Cell[13855, 448, 204, 5, 69, "Subsection"],

Cell[CellGroupData[{
Cell[14084, 457, 261, 7, 54, "Subsubsection"],
Cell[14348, 466, 264, 5, 39, "Text"],
Cell[14615, 473, 290, 5, 152, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14942, 483, 255, 7, 54, "Subsubsection"],
Cell[15200, 492, 706, 11, 407, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15943, 508, 239, 6, 54, "Subsubsection"],

Cell[CellGroupData[{
Cell[16207, 518, 112, 3, 69, "Input"],
Cell[16322, 523, 37, 1, 42, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[16408, 530, 260, 6, 54, "Subsubsection"],
Cell[16671, 538, 148, 4, 69, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[16868, 548, 228, 5, 70, "Subsection"],
Cell[17099, 555, 2549, 94, 339, "Text"]
}, Open  ]]
}, Open  ]],
Cell[19675, 653, 1679, 44, 20, "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{
Cell[21379, 701, 135, 2, 63, "Section"],

Cell[CellGroupData[{
Cell[21539, 707, 310, 7, 69, "Subsection"],
Cell[21852, 716, 148, 3, 57, "Subsubsection"],
Cell[22003, 721, 195, 4, 69, "Subsection"],
Cell[22201, 727, 184, 4, 69, "Subsection"]
}, Open  ]]
}, Open  ]],
Cell[22412, 735, 1679, 44, 20, "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{
Cell[24116, 783, 317, 6, 63, "Section"],

Cell[CellGroupData[{
Cell[24458, 793, 118, 2, 79, "Subsection"],
Cell[24579, 797, 290, 6, 52, "Subsubsection"],
Cell[24872, 805, 706, 11, 407, "Input"],
Cell[25581, 818, 187, 4, 39, "Text"],
Cell[25771, 824, 336, 7, 69, "Input"],
Cell[26110, 833, 322, 7, 69, "Input"],
Cell[26435, 842, 378, 11, 39, "Text"],
Cell[26816, 855, 362, 8, 92, "Input"],
Cell[27181, 865, 264, 8, 39, "Text"],
Cell[27448, 875, 1600, 43, 92, "Input"],
Cell[29051, 920, 166, 4, 39, "Text"],
Cell[29220, 926, 1654, 44, 92, "Input"],

Cell[CellGroupData[{
Cell[30899, 974, 164, 3, 69, "Input"],
Cell[31066, 979, 12853, 280, 455, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[43968, 1265, 134, 2, 81, "Subsection"],
Cell[44105, 1269, 264, 5, 52, "Subsubsection"],
Cell[44372, 1276, 236, 4, 95, "Input"],
Cell[44611, 1282, 538, 10, 303, "Input"],
Cell[45152, 1294, 188, 4, 39, "Text"],
Cell[45343, 1300, 274, 6, 69, "Input"],
Cell[45620, 1308, 306, 6, 69, "Input"],
Cell[45929, 1316, 215, 5, 69, "Input"],
Cell[46147, 1323, 112, 5, 39, "Text"],
Cell[46262, 1330, 680, 18, 38, "Text"],
Cell[46945, 1350, 79, 1, 69, "Input"],
Cell[47027, 1353, 544, 15, 38, "Text"],
Cell[47574, 1370, 165, 4, 105, "Input"],
Cell[47742, 1376, 200, 5, 105, "Input"],
Cell[47945, 1383, 141, 2, 70, "Text"],
Cell[48089, 1387, 259, 8, 39, "Text"],
Cell[48351, 1397, 301, 6, 105, "Input"],

Cell[CellGroupData[{
Cell[48677, 1407, 193, 3, 39, "Text"],

Cell[CellGroupData[{
Cell[48895, 1414, 239, 9, 36, "Text"],
Cell[49137, 1425, 268, 6, 69, "Input"],
Cell[49408, 1433, 170, 6, 40, "Text"],
Cell[49581, 1441, 188, 3, 69, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[49806, 1449, 334, 11, 86, "Text"],
Cell[50143, 1462, 115, 2, 39, "Text"],
Cell[50261, 1466, 103, 3, 39, "Text"],
Cell[50367, 1471, 142, 4, 69, "Input"],
Cell[50512, 1477, 141, 4, 69, "Input"],
Cell[50656, 1483, 120, 2, 39, "Text"],
Cell[50779, 1487, 133, 3, 39, "Text"],
Cell[50915, 1492, 210, 5, 88, "Input"],
Cell[51128, 1499, 131, 1, 39, "Text"],
Cell[51262, 1502, 161, 4, 92, "Input"],
Cell[51426, 1508, 120, 2, 39, "Text"],
Cell[51549, 1512, 270, 9, 40, "Text"],
Cell[51822, 1523, 245, 5, 104, "Input"],
Cell[52070, 1530, 263, 5, 105, "Input"],
Cell[52336, 1537, 113, 2, 70, "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[52498, 1545, 174, 3, 39, "Text"],

Cell[CellGroupData[{
Cell[52697, 1552, 101, 2, 69, "Input"],
Cell[52801, 1556, 15782, 331, 1032, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[68632, 1893, 40, 4, 31, "Text"],

Cell[CellGroupData[{
Cell[68697, 1901, 71, 0, 66, "Subsubsection"],
Cell[68771, 1903, 311, 12, 45, "Text"],
Cell[69085, 1917, 115, 1, 45, "Text"],
Cell[69203, 1920, 19, 0, 45, "Text"],
Cell[69225, 1922, 96, 1, 45, "Text"],
Cell[69324, 1925, 279, 5, 75, "Text"],
Cell[69606, 1932, 265, 9, 45, "Text"],
Cell[69874, 1943, 116, 1, 45, "Text"],
Cell[69993, 1946, 225, 6, 45, "Text"],
Cell[70221, 1954, 179, 6, 45, "Text"],
Cell[70403, 1962, 47, 1, 45, "Text"],
Cell[70453, 1965, 4383, 132, 204, "Input"],
Cell[74839, 2099, 668, 18, 162, "Text"],
Cell[75510, 2119, 73, 3, 75, "Text"],
Cell[75586, 2124, 1338, 39, 57, "Input"],
Cell[76927, 2165, 596, 15, 57, "Input"],
Cell[77526, 2182, 3954, 118, 168, "Input"],
Cell[81483, 2302, 1078, 30, 57, "Input"],
Cell[82564, 2334, 180, 6, 45, "Text"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[82795, 2346, 1679, 44, 20, "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{
Cell[84499, 2394, 376, 10, 63, "Section"],

Cell[CellGroupData[{
Cell[84900, 2408, 161, 3, 79, "Subsection"],
Cell[85064, 2413, 615, 11, 147, "Input"],
Cell[85682, 2426, 981, 16, 485, "Input"],

Cell[CellGroupData[{
Cell[86688, 2446, 174, 4, 79, "Subsection"],

Cell[CellGroupData[{
Cell[86887, 2454, 186, 5, 57, "Subsubsection"],
Cell[87076, 2461, 89, 1, 39, "Text"],

Cell[CellGroupData[{
Cell[87190, 2466, 1190, 22, 252, "Input"],
Cell[88383, 2490, 364, 7, 135, "Text"],
Cell[88750, 2499, 1023, 18, 278, "Input"]
}, Open  ]],
Cell[89788, 2520, 116, 3, 39, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[89941, 2528, 251, 8, 57, "Subsubsection"],
Cell[90195, 2538, 795, 24, 136, "Input"],
Cell[90993, 2564, 904, 24, 146, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[91934, 2593, 139, 3, 57, "Subsubsection"],
Cell[92076, 2598, 654, 16, 148, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[92767, 2619, 342, 12, 57, "Subsubsection"],
Cell[93112, 2633, 457, 8, 256, "Input"],
Cell[93572, 2643, 237, 6, 39, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[93846, 2654, 140, 3, 57, "Subsubsection"],
Cell[93989, 2659, 104, 1, 39, "Text"],
Cell[94096, 2662, 65, 1, 91, "Input"],
Cell[94164, 2665, 109, 2, 91, "Input"],
Cell[94276, 2669, 110, 1, 39, "Text"],
Cell[94389, 2672, 250, 4, 204, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[94676, 2681, 318, 10, 83, "Subsubsection"],
Cell[94997, 2693, 80, 1, 92, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[95114, 2699, 184, 4, 57, "Subsubsection"],
Cell[95301, 2705, 182, 3, 92, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[95532, 2714, 133, 3, 69, "Input"],
Cell[95668, 2719, 21401, 482, 607, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[117118, 3207, 173, 5, 79, "Subsection"],
Cell[117294, 3214, 448, 8, 147, "Input"],
Cell[117745, 3224, 1303, 23, 693, "Input"],

Cell[CellGroupData[{
Cell[119073, 3251, 116, 2, 57, "Subsubsection"],
Cell[119192, 3255, 389, 12, 142, "Input"],
Cell[119584, 3269, 248, 6, 39, "Text"],
Cell[119835, 3277, 355, 11, 68, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[120227, 3293, 112, 2, 57, "Subsubsection"],

Cell[CellGroupData[{
Cell[120364, 3299, 186, 4, 50, "Subsubsection"],
Cell[120553, 3305, 201, 5, 39, "Text"],
Cell[120757, 3312, 554, 11, 277, "Input"],
Cell[121314, 3325, 577, 11, 303, "Input"],
Cell[121894, 3338, 357, 7, 199, "Input"],
Cell[122254, 3347, 357, 7, 199, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[122648, 3359, 217, 4, 50, "Subsubsection"],
Cell[122868, 3365, 612, 13, 277, "Input"],
Cell[123483, 3380, 266, 7, 39, "Text"],
Cell[123752, 3389, 399, 12, 136, "Input"],
Cell[124154, 3403, 379, 12, 136, "Input"],
Cell[124536, 3417, 389, 12, 142, "Input"],
Cell[124928, 3431, 168, 4, 39, "Text"],
Cell[125099, 3437, 464, 12, 148, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[125600, 3454, 218, 4, 50, "Subsubsection"],
Cell[125821, 3460, 559, 14, 184, "Input"],
Cell[126383, 3476, 224, 6, 39, "Text"],
Cell[126610, 3484, 314, 5, 147, "Input"],
Cell[126927, 3491, 216, 7, 39, "Text"],
Cell[127146, 3500, 138, 2, 69, "Input"],
Cell[127287, 3504, 216, 7, 39, "Text"],
Cell[127506, 3513, 132, 2, 69, "Input"],
Cell[127641, 3517, 232, 9, 39, "Text"],
Cell[127876, 3528, 200, 5, 69, "Input"]
}, Open  ]],
Cell[128091, 3536, 172, 5, 46, "Subsubsection"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[128312, 3547, 138, 3, 79, "Subsection"],
Cell[128453, 3552, 395, 6, 147, "Input"],
Cell[128851, 3560, 715, 11, 407, "Input"],
Cell[129569, 3573, 37, 0, 39, "Text"],

Cell[CellGroupData[{
Cell[129631, 3577, 88, 1, 95, "Input"],
Cell[129722, 3580, 103, 2, 70, "Input"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[129864, 3587, 126, 4, 57, "Subsubsection"],
Cell[129993, 3593, 1679, 44, 20, "SlideShowNavigationBar",
  CellTags->"SlideShowHeader"],

Cell[CellGroupData[{
Cell[131697, 3641, 330, 7, 63, "Section"],

Cell[CellGroupData[{
Cell[132052, 3652, 318, 10, 70, "Text"],

Cell[CellGroupData[{
Cell[132395, 3666, 199, 4, 43, "Text"],
Cell[132597, 3672, 178, 4, 63, "Text"],
Cell[132778, 3678, 319, 6, 87, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[133134, 3689, 213, 7, 43, "Text"],
Cell[133350, 3698, 164, 4, 39, "Text"],
Cell[133517, 3704, 590, 14, 159, "Text"]
}, Open  ]]
}, Open  ]],
Cell[134134, 3722, 324, 13, 46, "Text"],
Cell[134461, 3737, 145, 4, 46, "Text"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

